import * as i0 from '@angular/core';
import { EventEmitter, HostListener, Output, Directive, NgModule, inject, Injectable, Component, Inject, HostBinding, Input } from '@angular/core';
import { Subject, BehaviorSubject } from 'rxjs';
import { ArrayUtils, NumericUtils, HTTPManager, StringUtils, HTTPManagerGetRequest, HTTPManagerPostRequest, BrowserManager, ConversionUtils } from 'turbocommons-ts';
import * as i1 from '@angular/material/dialog';
import { MAT_DIALOG_DATA } from '@angular/material/dialog';
import * as i3 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import { take, filter } from 'rxjs/operators';
import { trigger, transition, style, animate } from '@angular/animations';
import { ComponentPortal, DomPortalOutlet } from '@angular/cdk/portal';
import * as i2$1 from '@angular/material/datepicker';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { MatNativeDateModule } from '@angular/material/core';
import * as i1$1 from '@angular/material/snack-bar';
import * as i1$2 from '@angular/router';
import { NavigationEnd } from '@angular/router';
import * as i2$2 from '@angular/platform-browser';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i4 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i5 from '@angular/forms';
import { FormsModule, Validators } from '@angular/forms';

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/** This directive is used to trigger an event when the user clicks outside of an element */
/**
 * This directive is used to execute an action when the user clicks outside of an element.
 * If we set the elementClickOutside tag to the html element and set the onClickOutside event to a function: <element elementClickOutside (onClickOutside)="onClickedOutside()" ...,
 * this function will be executed when the user clicks outside of the element.
 */
class ElementClickOutsideDirective {
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.onClickOutside = new EventEmitter();
    }
    onClick(targetElement) {
        const clickedInside = this.elementRef.nativeElement.contains(targetElement);
        if (!clickedInside) {
            this.onClickOutside.emit();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ElementClickOutsideDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.2.5", type: ElementClickOutsideDirective, isStandalone: false, selector: "[elementClickOutside]", outputs: { onClickOutside: "onClickOutside" }, host: { listeners: { "document:click": "onClick($event.target)" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ElementClickOutsideDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[elementClickOutside]',
                    standalone: false
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { onClickOutside: [{
                type: Output
            }], onClick: [{
                type: HostListener,
                args: ['document:click', ['$event.target']]
            }] } });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/** This directive is used to listen for onInit events on raw html elements */
/**
 * This directive is used to listen for onInit events on raw html elements
 * If we place (elementCreated)="someMethod()" on the element at the html template part, when the element
 * that uses this directive is visually created, someMethod() will be called.
 */
class ElementCreatedDirective {
    constructor() {
        /**
         * Event that will be dispatched once element is created
         */
        this.elementCreated = new EventEmitter();
    }
    /**
     * Listen for the on init event
     */
    ngOnInit() {
        this.elementCreated.next(this);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ElementCreatedDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.2.5", type: ElementCreatedDirective, isStandalone: false, selector: "[elementCreated]", outputs: { elementCreated: "elementCreated" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ElementCreatedDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[elementCreated]',
                    standalone: false
                }]
        }], propDecorators: { elementCreated: [{
                type: Output,
                args: ['elementCreated']
            }] } });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/** This directive is used to listen for onDestroy events on raw html elements */
/**
 * This directive is used to listen for onDestroy events on raw html elements
 * If we place (elementDestroyed)="someMethod()" on the element at the html template part, when the element
 * that uses this directive is visually destroyed from the screen, someMethod() will be called.
 */
class ElementDestroyedDirective {
    constructor() {
        /**
         * Event that will be dispatched once element is destroyed
         */
        this.elementDestroyed = new EventEmitter();
    }
    /**
     * Listen for the on destroy event
     */
    ngOnDestroy() {
        this.elementDestroyed.next(this);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ElementDestroyedDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.2.5", type: ElementDestroyedDirective, isStandalone: false, selector: "[elementDestroyed]", outputs: { elementDestroyed: "elementDestroyed" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ElementDestroyedDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[elementDestroyed]',
                    standalone: false
                }]
        }], propDecorators: { elementDestroyed: [{
                type: Output,
                args: ['elementDestroyed']
            }] } });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/** This directive is used to perform an autofocus on an element every time it is displayed */
/**
 * This directive is used to perform an autofocus on an element every time it is displayed
 * If we set the autoFocusOnDisplay tag to the html element, it will be automatically focused after it is shown.
 */
class AutoFocusOnDisplayDirective {
    constructor(el, zone, renderer) {
        this.el = el;
        this.zone = zone;
        this.renderer = renderer;
        if (!el.nativeElement['focus']) {
            throw new Error('Element does not accept focus');
        }
    }
    ngAfterContentInit() {
        this.zone.runOutsideAngular(() => setTimeout(() => {
            this.renderer.selectRootElement(this.el.nativeElement).focus();
        }, 0));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: AutoFocusOnDisplayDirective, deps: [{ token: i0.ElementRef }, { token: i0.NgZone }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.2.5", type: AutoFocusOnDisplayDirective, isStandalone: false, selector: "[autoFocusOnDisplay]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: AutoFocusOnDisplayDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[autoFocusOnDisplay]',
                    standalone: false
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i0.NgZone }, { type: i0.Renderer2 }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/** This directive is used to perform an automatic select all text on an element every time it is focused */
/**
 * This directive is used to perform an an automatic select all text on an element every time it is focused.
 * If we set the autoSelectTextOnFocus tag to the html element, its text will be automatically selected after it gets the focus.
 */
class AutoSelectTextOnFocusDirective {
    constructor(el, renderer) {
        this.el = el;
        this.renderer = renderer;
        if (!el.nativeElement['select']) {
            throw new Error('Element does not accept select');
        }
    }
    onFocus() {
        this.renderer.selectRootElement(this.el.nativeElement).select();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: AutoSelectTextOnFocusDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.2.5", type: AutoSelectTextOnFocusDirective, isStandalone: false, selector: "[autoSelectTextOnFocus]", host: { listeners: { "focus": "onFocus($event)" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: AutoSelectTextOnFocusDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[autoSelectTextOnFocus]',
                    standalone: false
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i0.Renderer2 }], propDecorators: { onFocus: [{
                type: HostListener,
                args: ['focus', ['$event']]
            }] } });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * This file contains the root module that contains all the library declarations and exports.
 */
class TurboGuiAngularModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: TurboGuiAngularModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.5", ngImport: i0, type: TurboGuiAngularModule, declarations: [ElementClickOutsideDirective,
            ElementCreatedDirective,
            ElementDestroyedDirective,
            AutoFocusOnDisplayDirective,
            AutoSelectTextOnFocusDirective], exports: [ElementClickOutsideDirective,
            ElementCreatedDirective,
            ElementDestroyedDirective,
            AutoFocusOnDisplayDirective,
            AutoSelectTextOnFocusDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: TurboGuiAngularModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: TurboGuiAngularModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [],
                    declarations: [
                        ElementClickOutsideDirective,
                        ElementCreatedDirective,
                        ElementDestroyedDirective,
                        AutoFocusOnDisplayDirective,
                        AutoSelectTextOnFocusDirective
                    ],
                    providers: [],
                    exports: [
                        ElementClickOutsideDirective,
                        ElementCreatedDirective,
                        ElementDestroyedDirective,
                        AutoFocusOnDisplayDirective,
                        AutoSelectTextOnFocusDirective
                    ]
                }]
        }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Defines a base class that can be used to create singleton services which cannot be instantiated more than one time
 * during the whole application lifetime.
 *
 * To use it, simply extend this class and pass the parent class type to this constructor via super()
 */
class SingletoneStrictClass {
    constructor(classType) {
        const parent = inject(classType, { skipSelf: true, optional: true });
        if (parent) {
            throw Error(`[${classType.name}]: Can not create more than one instance`);
        }
    }
}

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * This is the main application event bus.
 * All global events that happen on the application are broadcasted by this service, and
 * can be listened by any application element who previously subscribed
 */
class NotificationService extends SingletoneStrictClass {
    constructor() {
        super(NotificationService);
        /**
         * The Observable instance that handles subscriptions and notifications
         */
        this._notifications = new Subject();
    }
    /**
     * used by other services or components to subscribe to all notifications that are generated by this service
     *
     * @param notificationHandler A method that will be used to receive each notification as a GUINotification instance
     *
     * @returns The new subscription object. Make sure to unsubscribe when not required anymore
     */
    subscribe(notificationHandler) {
        return this._notifications.subscribe(notificationHandler);
    }
    /**
     * Launch a notification to anyone who may be listening
     *
     * @param notification A notification instance to launch
     */
    send(notification) {
        this._notifications.next(notification);
    }
    /**
     * End a previously initiated subscription
     *
     * @param subscription A previously created subscription instance from which we want to unsubscribe
     */
    unsubscribe(subscription) {
        return subscription.unsubscribe();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: NotificationService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: NotificationService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: NotificationService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Captures all the application exceptions and performs any required action.
 * It also contains multiple general error management features.
 *
 * To define this class as your application error handler, you must add the following to your
 * Application providers:
 *      {
 *          provide: ErrorHandler,
 *          useClass: GlobalErrorService
 *      },
 *      GlobalErrorService
 *
 * You cannot access the error handler at runtime. If you need to modify any of the behaviours
 * or implement your custom ones, you must extend this class and set your new one as the error
 * handler provider.
 */
class GlobalErrorService extends SingletoneStrictClass {
    constructor() {
        super(GlobalErrorService);
        /**
         * Enables or disables the error notification to user via an alert box
         * Extend this class and override this value on your custom error handle to change it
         */
        this.showExceptionsToUser = true;
        /**
         * Enables or disables the error notification to user via an alert box
         * Extend this class and override this value on your custom error handle to change it
         */
        this.showExceptionsOnConsole = true;
        /**
         * Defines the text that will be used for the alert that is shown to the user when an exception happens
         * and showExceptionsToUser is true
         * Extend this class and override this value on your custom error handle to change it
         */
        this.errorAlertMessage = 'Application exception:\n\n';
    }
    /**
     * Show an alert with the received error detail and also log it to the js console.
     *
     * Angular expects at least this method to be implemented on any class that is used as a global exception handler.
     *
     * @param error An error instance
     */
    handleError(error) {
        if (this.showExceptionsToUser) {
            alert(this.errorAlertMessage + error);
        }
        if (this.showExceptionsOnConsole) {
            console.log(error);
        }
        throw error;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: GlobalErrorService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: GlobalErrorService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: GlobalErrorService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * This is the base class for all the dialog components that can be loaded by the dialog service class
 */
class DialogBaseComponent {
    /*
     * The name of the superclass must be set into this constant as it is required by the dialog service to identify dialogs as different.
     *
     * When you extend the dialog base class, simply declare this static constant with the exact same name as your class and you're done.
     * If this value is not set on the extended dialog component, a runtime exception will happen when trying to show the dialog.
     *
     * The root cause of this requirement is that when apps are compiled for production, class names are minified and this causes problems
     * when creating a dialog hash to uniquely identify a dialog instance. Therefore, a hardcoded class name is necesary.
     */
    static { this.DIALOG_CLASS_NAME = ''; }
    constructor(elementRef, dialogRef) {
        this.elementRef = elementRef;
        this.dialogRef = dialogRef;
    }
    ngAfterViewInit() {
        // Assign the component HTML identifier if it is specifically assigned to the dialogref instance
        if (this.dialogRef.id !== undefined && this.dialogRef.id !== '') {
            this.elementRef.nativeElement.id = this.dialogRef.id;
        }
    }
    /**
     * Method to be called by the dialogs that extend this base component when they want to close themselves.
     * It will perform the close of that dialog and also send an object to the addDialog() callback with the index and value
     * that the user may have selected.
     *
     * @param index The numeric index of the user option selection. It will be specific for each dialog and it's different available options
     * @param value Any value that may be provided to the callback regarding the user selected option.
     *
     * @return void
     */
    closeDialog(index, value = null) {
        this.dialogRef.close({ index: index, value: value });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogBaseComponent, deps: [{ token: i0.ElementRef }, { token: i1.MatDialogRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: DialogBaseComponent, isStandalone: false, selector: "ng-component", ngImport: i0, template: '', isInline: true }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogBaseComponent, decorators: [{
            type: Component,
            args: [{
                    template: '',
                    standalone: false
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1.MatDialogRef }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * A dialog component with a single option button, to be used for error notifications
 */
class DialogErrorComponent extends DialogBaseComponent {
    static { this.DIALOG_CLASS_NAME = 'DialogErrorComponent'; }
    constructor(elementRef, dialogRef, data) {
        super(elementRef, dialogRef);
        this.elementRef = elementRef;
        this.dialogRef = dialogRef;
        this.data = data;
        if (data.texts.length < 1) {
            throw new Error('DialogErrorComponent expects 2 texts: The title and optionally a description');
        }
        if (data.options.length !== 1) {
            throw new Error('DialogErrorComponent expects only one option');
        }
        if (data.texts.length > 1) {
            data.texts[1] = data.texts[1].replace(/\n/g, "<br/>");
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogErrorComponent, deps: [{ token: i0.ElementRef }, { token: i1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: DialogErrorComponent, isStandalone: true, selector: "tg-dialog-error", providers: [], usesInheritance: true, ngImport: i0, template: "<div class=\"titleAndIconContainer\">\r\n    <h3>\r\n        {{data.texts[0]}}\r\n    </h3>\r\n    \r\n    <!-- error icon -->\r\n    <svg xmlns=\"http://www.w3.org/2000/svg\" height=\"24\" viewBox=\"0 0 24 24\" width=\"24\">\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"/>\r\n        <path d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-2h2v2zm0-4h-2V7h2v6z\" fill=\"#ff0000\" />\r\n    </svg>\r\n    \r\n</div>\r\n\r\n<div class=\"textContainer\">\r\n    <p *ngIf=\"data.texts.length > 1\" [innerHTML]=\"data.texts[1]\">\r\n    </p>\r\n</div>\r\n\r\n<button mat-raised-button color=\"warn\"\r\n    (click)=\"closeDialog(0)\">\r\n    \r\n    {{data.options[0]}}\r\n    \r\n</button>", styles: [":host{position:relative;min-height:300px}.titleAndIconContainer{display:flex;flex-direction:row;align-items:center;justify-content:space-between}svg{height:10vh;width:auto}.textContainer{margin-top:5px;max-height:70vh;overflow:auto}p{-webkit-user-select:text;user-select:text}h3{margin-top:0;margin-bottom:25px;width:82%}button{width:100%;margin-top:5px}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogErrorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tg-dialog-error', imports: [CommonModule, MatButtonModule], providers: [], template: "<div class=\"titleAndIconContainer\">\r\n    <h3>\r\n        {{data.texts[0]}}\r\n    </h3>\r\n    \r\n    <!-- error icon -->\r\n    <svg xmlns=\"http://www.w3.org/2000/svg\" height=\"24\" viewBox=\"0 0 24 24\" width=\"24\">\r\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"/>\r\n        <path d=\"M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-2h2v2zm0-4h-2V7h2v6z\" fill=\"#ff0000\" />\r\n    </svg>\r\n    \r\n</div>\r\n\r\n<div class=\"textContainer\">\r\n    <p *ngIf=\"data.texts.length > 1\" [innerHTML]=\"data.texts[1]\">\r\n    </p>\r\n</div>\r\n\r\n<button mat-raised-button color=\"warn\"\r\n    (click)=\"closeDialog(0)\">\r\n    \r\n    {{data.options[0]}}\r\n    \r\n</button>", styles: [":host{position:relative;min-height:300px}.titleAndIconContainer{display:flex;flex-direction:row;align-items:center;justify-content:space-between}svg{height:10vh;width:auto}.textContainer{margin-top:5px;max-height:70vh;overflow:auto}p{-webkit-user-select:text;user-select:text}h3{margin-top:0;margin-bottom:25px;width:82%}button{width:100%;margin-top:5px}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Fade animations
 */
class FadeAnimationClass {
    /**
     * Get a custom trigger to create fade animations when components are added or removed from the application
     *
     * @param triggerName The name for the trigger we want to create
     * @param enter The time and easing that we want to use for the enter state
     * @param leave The time and easing that we want to use for the leave state
     */
    static getTrigger(triggerName, enter = '1s ease', leave = '300ms ease') {
        return trigger(triggerName, [
            transition('void => *', [style({ opacity: 0 }), animate(enter, style({ opacity: 1 }))]),
            transition('* => void', [animate(leave, style({ opacity: 0 }))])
        ]);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: FadeAnimationClass, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: FadeAnimationClass }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: FadeAnimationClass, decorators: [{
            type: Injectable
        }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * This component is used by turboGUI angular library to show the busy state to the user.
 * It is used to block all the user input and progressively shows a busy cursor to notify that the application
 * is waiting for something.
 *
 * We can (should) override this component with our own one to adapt its visual appearance to our application.
 * We can then set dialogService.busyStateComponentClass to our component class at the application start to to
 * override the default one.
 */
class BusyStateBaseComponent {
    constructor() {
        /**
         * This is used to attach the fade animation directly to this component so it fades in and out when created and removed from the app
         */
        this.busyStateBaseFade = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: BusyStateBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: BusyStateBaseComponent, isStandalone: true, selector: "tg-busy-state-base", host: { properties: { "@busyStateBaseFade": "this.busyStateBaseFade" } }, providers: [], ngImport: i0, template: "<div class=\"darkBg\">\r\n\r\n</div>\r\n\r\n<svg width=\"38\" height=\"38\" viewBox=\"0 0 38 38\" xmlns=\"http://www.w3.org/2000/svg\" stroke=\"#fff\">\r\n    <g fill=\"none\" fill-rule=\"evenodd\">\r\n        <g transform=\"translate(1 1)\" stroke-width=\"1\">\r\n            <circle stroke-opacity=\".2\" cx=\"18\" cy=\"18\" r=\"18\"/>\r\n            <path d=\"M36 18c0-9.94-8.06-18-18-18\">\r\n                <animateTransform\r\n                    attributeName=\"transform\"\r\n                    type=\"rotate\"\r\n                    from=\"0 18 18\"\r\n                    to=\"360 18 18\"\r\n                    dur=\"1s\"\r\n                    repeatCount=\"indefinite\"/>\r\n            </path>\r\n        </g>\r\n    </g>\r\n</svg>\r\n", styles: [":host{position:fixed;inset:0;display:flex;justify-content:center;align-items:center;z-index:999999999}.darkBg{position:absolute;cursor:progress;width:100%;height:100%;display:flex;justify-content:center;align-items:center;background-color:#00000096;animation-name:bgfadein;animation-duration:30s;animation-timing-function:ease}svg{z-index:5000;width:40%;height:40%;max-width:130px;max-height:130px;animation-name:loadingfadein;animation-duration:3s;animation-timing-function:ease-in}@keyframes loadingfadein{0%{opacity:0}25%{opacity:0}to{opacity:1}}@keyframes bgfadein{0%{opacity:0}4%{opacity:0}14%{opacity:.2}35%{opacity:.5}to{opacity:1}}\n"], animations: [FadeAnimationClass.getTrigger('busyStateBaseFade', '1s ease', '400ms ease')] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: BusyStateBaseComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tg-busy-state-base', imports: [], providers: [], animations: [FadeAnimationClass.getTrigger('busyStateBaseFade', '1s ease', '400ms ease')], template: "<div class=\"darkBg\">\r\n\r\n</div>\r\n\r\n<svg width=\"38\" height=\"38\" viewBox=\"0 0 38 38\" xmlns=\"http://www.w3.org/2000/svg\" stroke=\"#fff\">\r\n    <g fill=\"none\" fill-rule=\"evenodd\">\r\n        <g transform=\"translate(1 1)\" stroke-width=\"1\">\r\n            <circle stroke-opacity=\".2\" cx=\"18\" cy=\"18\" r=\"18\"/>\r\n            <path d=\"M36 18c0-9.94-8.06-18-18-18\">\r\n                <animateTransform\r\n                    attributeName=\"transform\"\r\n                    type=\"rotate\"\r\n                    from=\"0 18 18\"\r\n                    to=\"360 18 18\"\r\n                    dur=\"1s\"\r\n                    repeatCount=\"indefinite\"/>\r\n            </path>\r\n        </g>\r\n    </g>\r\n</svg>\r\n", styles: [":host{position:fixed;inset:0;display:flex;justify-content:center;align-items:center;z-index:999999999}.darkBg{position:absolute;cursor:progress;width:100%;height:100%;display:flex;justify-content:center;align-items:center;background-color:#00000096;animation-name:bgfadein;animation-duration:30s;animation-timing-function:ease}svg{z-index:5000;width:40%;height:40%;max-width:130px;max-height:130px;animation-name:loadingfadein;animation-duration:3s;animation-timing-function:ease-in}@keyframes loadingfadein{0%{opacity:0}25%{opacity:0}to{opacity:1}}@keyframes bgfadein{0%{opacity:0}4%{opacity:0}14%{opacity:.2}35%{opacity:.5}to{opacity:1}}\n"] }]
        }], propDecorators: { busyStateBaseFade: [{
                type: HostBinding,
                args: ['@busyStateBaseFade']
            }] } });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * A dialog component with a calendar that allows us to select a single date value
 */
class DialogDateSelectionComponent extends DialogBaseComponent {
    static { this.DIALOG_CLASS_NAME = 'DialogDateSelectionComponent'; }
    constructor(elementRef, dialogRef, data) {
        super(elementRef, dialogRef);
        this.elementRef = elementRef;
        this.dialogRef = dialogRef;
        this.data = data;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogDateSelectionComponent, deps: [{ token: i0.ElementRef }, { token: i1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: DialogDateSelectionComponent, isStandalone: true, selector: "tg-dialog-date-selection", providers: [], usesInheritance: true, ngImport: i0, template: "<h2>{{data.texts[0]}}</h2>\r\n\r\n<mat-calendar #calendar\r\n    (selectedChange)=\"closeDialog(0, $event)\">\r\n</mat-calendar>", styles: [":host{position:relative;min-height:300px}h1{margin-top:0;margin-bottom:25px;width:82%}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "ngmodule", type: MatDatepickerModule }, { kind: "component", type: i2$1.MatCalendar, selector: "mat-calendar", inputs: ["headerComponent", "startAt", "startView", "selected", "minDate", "maxDate", "dateFilter", "dateClass", "comparisonStart", "comparisonEnd", "startDateAccessibleName", "endDateAccessibleName"], outputs: ["selectedChange", "yearSelected", "monthSelected", "viewChanged", "_userSelection", "_userDragDrop"], exportAs: ["matCalendar"] }, { kind: "ngmodule", type: MatNativeDateModule }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogDateSelectionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tg-dialog-date-selection', imports: [CommonModule, MatDatepickerModule, MatNativeDateModule], providers: [], template: "<h2>{{data.texts[0]}}</h2>\r\n\r\n<mat-calendar #calendar\r\n    (selectedChange)=\"closeDialog(0, $event)\">\r\n</mat-calendar>", styles: [":host{position:relative;min-height:300px}h1{margin-top:0;margin-bottom:25px;width:82%}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Manages the application modal and non modal floating elements
 */
class DialogService extends SingletoneStrictClass {
    constructor(rendererFactory, matSnackBar, matDialog, injector, applicationRef, environmentInjector) {
        super(DialogService);
        this.matSnackBar = matSnackBar;
        this.matDialog = matDialog;
        this.injector = injector;
        this.applicationRef = applicationRef;
        this.environmentInjector = environmentInjector;
        /**
         * Used to modify the busy state component that is shown by default by the addModalBusyState() method.
         *
         * @see this.addModalBusyState()
         */
        this.customBusyStateComponentClass = BusyStateBaseComponent;
        /**
         * Check public getter for docs
         */
        this._isEnabled = true;
        /**
         * Tells if the main application is currently showing a busy state that blocks all user interaction
         */
        this._isShowingBusyState = false;
        /**
         * A reference to the modal busy state component that is initialized only the first time it is called.
         *
         * (To append the busy state dynamically, we use the Portal concept from the angular material library)
         */
        this._componentPortal = null;
        /**
         * A reference to the modal busy state container where the component will be added
         */
        this._modalBusyStateHost = null;
        /**
         * Tells if the manager is currently showing a snackbar element or not
         */
        this._isShowingSnackBar = false;
        /**
         * Contains a list of the dialogs (MODAL AND NON MODAL) that are currently visible to the user.
         * Each item in this list is a hash that is computed when dialog is created to uniquely identify it.
         *
         * Empty list means no dialogs are currently visible
         */
        this._activeDialogs = [];
        /**
         * Contains a list with all the MatDialog instances that are currently visible to the user.
         * The list uses the same order as the list of _activeDialogs hash values
         */
        this._activeDialogInstances = [];
        /**
         * Counts the number of dialogs that are currently open and that can be closed by the user by navigating with the browser
         */
        this._activeCloseableDialogs = 0;
        /**
         * Method that is used to delete the window beforeunload event listener once not used anymore
         */
        this._windowBeforeUnloadUnListen = null;
        /**
         * Method that is used to delete the document keydown event listener once not used anymore
         */
        this._documentKeydownUnlisten = null;
        /**
         * Method that is used to delete the document mousedown event listener once not used anymore
         */
        this._documentMousedownUnlisten = null;
        /**
         * Method that is used to delete the document pointerdown event listener once not used anymore
         */
        this._documentPointerdownUnlisten = null;
        this._renderer = rendererFactory.createRenderer(null, null);
    }
    /**
     * Tells if this dialog service is enabled or not. If dialog service is disabled, none of it's features will work
     * This is used to block all dialog features normally when shutting down the application
     *
     * Use with caution. When this is set to false, dialog service stops working.
     */
    set isEnabled(v) {
        if (v === this._isEnabled) {
            return;
        }
        this._isEnabled = v;
    }
    /**
     * Enables a warning that will be shown to the user when he/she tries to close the application.
     * This warning will prompt the user to continue with the exit process or cancel it.
     * The specific texts of this message are a generic ones and cannot be changed.
     *
     * IMPORTANT: This method must be called after the main application has been initialized in order to work,
     * otherwise it will do nothing.
     */
    addCloseApplicationWarning() {
        this._windowBeforeUnloadUnListen ??= this._renderer.listen('window', 'beforeunload', (event) => event.returnValue = true);
    }
    /**
     * Remove the close application warning message if previously assigned
     */
    removeCloseApplicationWarning() {
        if (this._windowBeforeUnloadUnListen !== null) {
            this._windowBeforeUnloadUnListen();
            this._windowBeforeUnloadUnListen = null;
        }
    }
    /**
     * Change the application visual appearance so the user perceives that the application is
     * currently busy. While modal busy state is enabled, no user input is possible neither via
     * keyboard, mouse or touch. Use this state when performing server requests or operations that
     * must block the user interaction with the application. To allow user interaction again, you must
     * call removeModalBusyState()
     *
     * Notice: We can modify the busy state visual component that is shown by this method. To do it, we must
     * set this.customBusyStateComponentClass property with our own custom busy state component class. (We can do it at
     * our main application component constructor for example). Our custom component must extend the
     * BusyStateBaseComponent one to add its own visual appearance.
     *
     * @see this.customBusyStateComponentClass
     */
    addModalBusyState() {
        if (!this._isEnabled || this._isShowingBusyState) {
            return;
        }
        this._disableUserInteraction();
        // Dynamically create the busy state component reference if this is the first time
        if (this._componentPortal === null) {
            this._componentPortal = new ComponentPortal(this.customBusyStateComponentClass);
            // Create a PortalHost with document.body as its anchor element
            this._modalBusyStateHost = new DomPortalOutlet(document.body, this.environmentInjector, this.applicationRef, this.injector);
        }
        this._modalBusyStateHost.attach(this._componentPortal);
        this._isShowingBusyState = true;
    }
    /**
     * Tells if the application is currently locked in a modal busy state (caused by an addModalBusyState() call)
     */
    get isShowingBusyState() {
        return this._isShowingBusyState;
    }
    /**
     * Cancel the application busy state and restore it back to normal so user interaction is allowed again
     */
    removeModalBusyState() {
        if (!this._isEnabled || !this._isShowingBusyState) {
            return;
        }
        if (this._componentPortal !== null) {
            this._modalBusyStateHost.detach();
        }
        this._enableUserInteraction();
        this._isShowingBusyState = false;
    }
    /**
     * TODO - adapt from TS version
     */
    addToolTip() {
        // TODO - adapt from TS version
    }
    /**
     * Show a non modal snackbar notification to the user (Only one snack-bar can ever be opened at the same time).
     *
     * Snackbars inform users of a process that an app has performed or will perform. They appear temporarily, towards the bottom or top of the screen.
     * They shouldn’t interrupt the user experience, and they don’t require user input to disappear.
     *
     * @param config A MatSnackBarConfig instance with the customizations we want for this snackbar
     * @param message The message to show on the snackbar
     * @param action If not empty, the text to place on the snackbar confirmation button
     * @param actionCallback A method to execute once the user clicks into the action button.
     *
     * @return A promise that will be resolved once the snackbar is closed.
     */
    addSnackBar(config, message, action = '') {
        if (!this._isEnabled) {
            return Promise.reject(new Error('Dialog service is disabled'));
        }
        if (this._isShowingSnackBar) {
            throw new Error('Trying to show a snackbar while another one is still visible');
        }
        this._isShowingSnackBar = true;
        return new Promise((resolve) => {
            const snackBarRef = this.matSnackBar.open(message, action === '' ? undefined : action, config);
            // Handle action button click
            snackBarRef.onAction().pipe(take(1)).subscribe(() => {
                this._isShowingSnackBar = false;
                resolve(true);
            });
            // Handle dismiss
            snackBarRef.afterDismissed().pipe(take(1)).subscribe(() => {
                this._isShowingSnackBar = false;
                resolve(false);
            });
        });
    }
    /**
     * Tells if the application is currently showing a snackbar or not
     */
    get isShowingSnackBar() {
        return this._isShowingSnackBar;
    }
    /**
     * Force the removal of the snack bar dialog if it exists.
     *
     * If no snackbar is currently visible, this method will do nothing
     */
    removeSnackBar() {
        if (!this._isEnabled || !this._isShowingSnackBar) {
            return;
        }
        this.matSnackBar.dismiss();
        this._isShowingSnackBar = false;
    }
    /**
     * Show a dialog with one or more options that can be used to close it. We can use any of the predefined dialog types that are bundled with
     * this library or extend DialogBaseComponent to create our own custom ones.
     *
     * @param dialogComponentClass A class for a component that extends DialogBaseComponent, which will be the dialog that is shown to the user.
     * @param properties An object containing the different visual and textual options that this dialog allows.
     *                   IMPORTANT: texts, options and data values need to be read at the dialog component by declaring "@Inject(MAT_DIALOG_DATA) public data: any"
     *                   at the dialog component constructor. This data object will contain the texts, options and data properties
     *
     *            - id: The html unique identifier that the dialog will have once created. If not specified, no id will be explicitly set
     *            - width: 50% by default. Specify the css value for the default dialog width. As the dialog is responsive, the value will be automatically
     *              reduced if the available screen is not enough, and will reach the desired value otherwise. We can set any css unit like pixels,
     *              %, vh, vw, or any other. For example: '400px', '50%', etc.
     *            - maxWidth: Defines the maximum width that the dialog will have. We can specify it in % or vw, just like is done in
     *              css. By default it is defined as 96vw, which will fit 96% of the viewport on small devices
     *            - height: Unset by default. Specify the css value for the dialog height.
     *            - maxHeight: Defines the maximum height that the dialog will have. We can specify it in % or vh, just like is done in
         *          css. By default it is defined as 96vh, which will fit 96% of the viewport
     *            - modal: True (default) if selecting an option is mandatory to close the dialog, false if the dialog can be closed
     *              by the user clicking outside it
     *            - closeOnNavigation: Tells if the dialog should be closed when the user navigates with the browser. By default is true for non modal and false for modal dialogs.
     *            - texts: A list with strings containing the dialog texts, sorted by importance. When dialog has a title, this should
     *              be placed first, subtitle second and so (Each dialog may accept a different custom number of texts).
     *              (add "@Inject(MAT_DIALOG_DATA) public data: any" to dialog constructor and read it with data.texts)
     *            - options: A list of strings that will be used as button captions for each one of the accepted dialog options
     *              (add "@Inject(MAT_DIALOG_DATA) public data: any" to dialog constructor and read it with data.options)
     *            - data: An object to pass any extra data we want to the dialog.
     *              (add "@Inject(MAT_DIALOG_DATA) public data: any" to dialog constructor and read it with data.data)
     *            - viewContainerRef: This is important if we want to propagate providers from a parent component to this dialog. We must specify
     *              this reference to make sure the same services injected on the parent are available too at the child dialog
     *
     * @return A promise that will be resolved once the dialog is closed.
     *         The promise will receive a selection object with two properties which will correspond to the index and value from the options
     *         array that's selected by the user. If no option selected, index will be -1 and value null
     */
    addDialog(dialogComponentClass, properties) {
        if (!this._isEnabled) {
            return Promise.reject(new Error('Dialog service is disabled'));
        }
        return new Promise((resolve) => {
            // Set the default values for non specified properties
            properties.modal = properties.modal ?? true;
            properties.closeOnNavigation = properties.closeOnNavigation ?? !properties.modal;
            properties.texts = properties.texts ?? [];
            properties.options = properties.options ?? [];
            properties.data = properties.data ?? {};
            // Generate a string to uniquely identify this dialog on the list of active dialogs
            // A dialog is considered as unique if the dialog id and texts are exactly the same. We do not take options into consideration
            // as there may be dialogs with a big amount of options available.
            let className = dialogComponentClass.DIALOG_CLASS_NAME;
            if (className === '') {
                throw new Error(`The static property DIALOG_CLASS_NAME is not defined or is empty for this dialog component (${dialogComponentClass})`);
            }
            const dialogHash = className + properties.texts.join('');
            // identical dialogs won't be allowed at the same time
            if (this._activeDialogs.includes(dialogHash)) {
                return resolve({ index: -1 });
            }
            let dialogRefConfig = {
                width: properties.width ?? "50%",
                maxWidth: properties.maxWidth ?? "96vw",
                maxHeight: properties.maxHeight ?? "96vh",
                disableClose: properties.modal,
                autoFocus: false,
                closeOnNavigation: properties.closeOnNavigation,
                viewContainerRef: properties.viewContainerRef,
                data: { texts: properties.texts, options: properties.options, data: properties.data }
            };
            // Dialog height will only be set if it is specified on properties
            if (properties.height && properties.height !== undefined) {
                dialogRefConfig['height'] = properties.height;
            }
            const dialogRef = this.matDialog.open(dialogComponentClass, dialogRefConfig);
            // Push a new state to handle browser navigation to close the dialog
            if (properties.closeOnNavigation && this._activeCloseableDialogs === 0) {
                history.pushState({ dialogOpen: true }, '');
            }
            // Assign the dialog ID only if specifically set on properties
            if (properties.id && properties.id !== undefined) {
                dialogRef.id = properties.id;
            }
            this._activeDialogs.push(dialogHash);
            this._activeDialogInstances.push(dialogRef);
            if (properties.closeOnNavigation) {
                this._activeCloseableDialogs += 1;
            }
            dialogRef.beforeClosed().pipe(take(1)).subscribe((selection) => {
                this._activeDialogs = ArrayUtils.removeElement(this._activeDialogs, dialogHash);
                this._activeDialogInstances = ArrayUtils.removeElement(this._activeDialogInstances, dialogRef);
                if (properties.closeOnNavigation) {
                    // Remove dialog state from browser history
                    if (this._activeCloseableDialogs === 1 && window.history.state?.dialogOpen) {
                        history.back();
                    }
                    this._activeCloseableDialogs -= 1;
                }
                if (!properties.modal && selection === undefined) {
                    selection = { index: -1 };
                }
                else if (!NumericUtils.isInteger(selection.index)) {
                    throw new Error(`closeDialog() expects index to be an integer`);
                }
                if (selection.index >= 0 && selection.value === null) {
                    selection.value = properties.options[selection.index];
                }
                resolve(selection);
            });
        });
    }
    /**
     * Show a dialog with a calendar to let the user pick a date.
     *
     * @param properties An object containing the different visual and textual options that this dialog allows:
     *            - id: The html unique identifier that the dialog will have once created. If not specified, no id will be explicitly set
     *            - width: Specify the css value for the default dialog width. As the dialog is responsive, the value will be automatically
     *              reduced if the available screen is not enough, and will reach the desired value otherwise. We can set any css unit like pixels,
     *              %, vh, vw, or any other. For example: '400px', '50%', etc.
     *            - maxWidth: Defines the maximum width that the dialog will have regarding the viewport. We can specify it in % or vw, just like is done in
     *              css. By default it is defined as 96vw, which will fit 96% of the viewport on small devices
     *            - height: TODO docs
     *            - maxHeight: TODO docs
     *            - modal: True (default) if selecting an option is mandatory to close the dialog, false if the dialog can be closed
     *              by the user clicking outside it
     *            - title: An optional dialog title
     *            - viewContainerRef: This is important to propagate providers from a parent component to this dialog. We must specify
     *              this reference to make sure the same services injected on the parent are available too at the child dialog
     *
     * @returns A Promise that resolves to a Date() object selected by the user or null if no selection was made
     */
    async addDateSelectionDialog(properties) {
        if (!this._isEnabled) {
            return null;
        }
        const selection = await this.addDialog(DialogDateSelectionComponent, {
            id: properties.id ?? undefined,
            width: properties.width ?? "50%",
            maxWidth: properties.maxWidth ?? "96vw",
            height: properties.height ?? "auto",
            maxHeight: properties.maxHeight ?? "92vw",
            modal: properties.modal ?? false,
            texts: [properties.title ?? ''],
            viewContainerRef: properties.viewContainerRef
        });
        return selection.index === -1 ? null : selection.value;
    }
    /**
     * Force the removal of all the dialogs that are currently visible.
     *
     * If no dialogs are currently visible, this method will do nothing
     */
    removeAllDialogs() {
        if (!this._isEnabled) {
            return;
        }
        // If there are dialogs that should close on navigation and a history state was pushed, pop it
        if (this._activeCloseableDialogs > 0 && window.history.state?.dialogOpen) {
            history.back();
        }
        for (const dialogRef of this._activeDialogInstances) {
            dialogRef.close({ index: -1 });
        }
        this._activeDialogs = [];
        this._activeDialogInstances = [];
        this._activeCloseableDialogs = 0;
    }
    /**
     * TODO - translate from TS version
     */
    //    addSideNav(){
    //
    //    }
    /**
     * TODO - translate from TS version
     */
    //    get isShowingSideNav(){
    //
    //    }
    /**
     * TODO - translate from TS version
     */
    //    removeSideNav(){
    //
    //    }
    /**
     * Block all the user interactions with the application (keyboard, touch, mouse, ...)
     */
    _disableUserInteraction() {
        this._documentKeydownUnlisten ??= this._renderer.listen('document', 'keydown', (event) => event.preventDefault());
        this._documentMousedownUnlisten ??= this._renderer.listen('document', 'mousedown', (event) => event.preventDefault());
        this._documentPointerdownUnlisten ??= this._renderer.listen('document', 'pointerdown', (event) => event.preventDefault());
    }
    /**
     * Restore the user interactions that were previously disabled with _disableUserInteraction method
     */
    _enableUserInteraction() {
        if (this._documentKeydownUnlisten !== null) {
            this._documentKeydownUnlisten();
            this._documentKeydownUnlisten = null;
        }
        if (this._documentMousedownUnlisten !== null) {
            this._documentMousedownUnlisten();
            this._documentMousedownUnlisten = null;
        }
        if (this._documentPointerdownUnlisten !== null) {
            this._documentPointerdownUnlisten();
            this._documentPointerdownUnlisten = null;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogService, deps: [{ token: i0.RendererFactory2 }, { token: i1$1.MatSnackBar }, { token: i1.MatDialog }, { token: i0.Injector }, { token: i0.ApplicationRef }, { token: i0.EnvironmentInjector }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: i0.RendererFactory2 }, { type: i1$1.MatSnackBar }, { type: i1.MatDialog }, { type: i0.Injector }, { type: i0.ApplicationRef }, { type: i0.EnvironmentInjector }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Manages application http communications
 */
class HTTPService extends HTTPManager {
    constructor(dialogService) {
        super(true);
        this.dialogService = dialogService;
    }
    /**
     * The same method as HTTPManager.execute but with the ability to enable several options which are specific to this service:
     *
     * - options:
     *     busyState: Set it to false to prevent the default behaviour of locking the UI while the request is running
     *     handleErrors: Set it to false to prevent the default behaviour of showing a detailed error dialog when a request fails
     *
     * @see HTTPManager.execute()
     */
    execute(requests, finishedCallback = null, progressCallback = null, options = {}) {
        // Set the default values for non specified properties
        options.busyState = options.busyState ?? true;
        options.handleErrors = options.handleErrors ?? true;
        if (options.busyState) {
            this.dialogService.addModalBusyState();
        }
        super.execute(requests, (results, anyError) => {
            if (options.busyState) {
                this.dialogService.removeModalBusyState();
            }
            if (options.handleErrors && anyError) {
                for (let result of results) {
                    if (result.isError) {
                        let errorMsg = result.errorMsg + '\n\n' + result.response;
                        if (StringUtils.isEmpty(errorMsg)) {
                            errorMsg = 'Unknown error. Make sure Internet connection is available';
                        }
                        this.dialogService.addDialog(DialogErrorComponent, {
                            width: '50vw',
                            texts: ['Error: ' + result.code, errorMsg],
                            options: ['Ok']
                        });
                    }
                }
            }
            if (finishedCallback !== null) {
                finishedCallback(results, anyError);
            }
        }, progressCallback);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: HTTPService, deps: [{ token: DialogService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: HTTPService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: HTTPService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: DialogService }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Class that defines a GET http request, to be used by HttpService
 */
class HTTPServiceGetRequest extends HTTPManagerGetRequest {
}

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Class that defines a POST http request, to be used by HttpService
 */
class HTTPServicePostRequest extends HTTPManagerPostRequest {
}

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * An abstraction of the browser entity an all its related operations and properties
 */
class BrowserService extends BrowserManager {
    constructor(location) {
        super();
        this.location = location;
    }
    /**
     * Modify the current browser URI without reloading the current page document
     *
     * @param path The uri value we want to set
     * @param query The query url parameters part we want to specify if any
     *
     * @returns void
     */
    setCurrentUrlURI(path, query) {
        this.location.go(path, query);
    }
    /**
     * Obtain a subscription to get notified on any changes at the browser url
     *
     * @param onNext A method to be executed every time the url changes on the browser. The url will be available inside the value parameter
     *
     * @returns Subscribed events. Make sure to unsubscribe when not needed
     */
    subscribeToUrlChange(onNext) {
        return this.location.subscribe(onNext);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: BrowserService, deps: [{ token: i2.Location }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: BrowserService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: BrowserService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: i2.Location }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Allows us to easily perform requests to a remote API that is developed with Turbo framework.
 */
class TurboApiService {
    constructor(dialogService, browserService) {
        this.dialogService = dialogService;
        this.browserService = browserService;
        /**
         * URI Path to the web service that performs the user login
         */
        this.loginServiceURI = 'users/login';
        /**
         * URI Path to the web service that allows us to create extra user tokens
         */
        this.tokenCreationServiceURI = 'users/user-token-create';
        /**
         * URI Path to the web service that performs the user log out
         */
        this.logOutServiceURI = 'users/logout';
        /**
         * URI Path to the web service that performs the verification for a user email
         */
        this.mailVerifyServiceURI = 'users/user-mail-verify';
        /**
         * The username that is currently defined and will be used by the login methods
         */
        this._userName = '';
        /**
         * The password for the user that is currently defined and will be used by the login methods
         */
        this._password = '';
        /**
         * Contains the last email account that has been verified (or tried to verify) by this service, if any
         */
        this._lastVerifiedMail = '';
        /**
         * Check public getter for docs
         */
        this._isLogged = false;
        /**
         * @see token() getter for more info
         */
        this._token = '';
        /**
         * List of operations that are allowed to the currently loged user. It gets filled just after login is performed
         */
        this._operations = [];
        // Create a fresh instance of the http service so we can use it independently
        this.httpManager = new HTTPManager();
        this._clearUserAndToken();
    }
    /**
     * The username that is currently defined and will be used by the login methods
     */
    set userName(v) {
        this._isLogged = false;
        this._token = '';
        this._userName = v;
    }
    /**
     * The username that is currently defined and will be used by the login methods
     */
    get userName() {
        return this._userName;
    }
    /**
     * The password for the user that is currently defined and will be used by the login methods
     */
    set password(v) {
        this._isLogged = false;
        this._token = '';
        this._password = v;
    }
    /**
     * The password for the user that is currently defined and will be used by the login methods
     */
    get password() {
        return this._password;
    }
    /**
     * Define the root url that will be used for all the API calls
     */
    set baseUrl(url) {
        this.httpManager.baseUrl = url;
    }
    /**
     * Define the root url that will be used for all the API calls
     */
    get baseUrl() {
        return this.httpManager.baseUrl;
    }
    /**
     * If the current browser URL contains a hash fragment (The part after the # character) that contains encoded user or password
     * values, this method will parse and automatically set them as the credentials to use.
     *
     * The URL hash is not altered in any way by this method.
     *
     * @returns True if any credentials were found and loaded, false if nothing happened
     */
    loadCredentialsFromURLHashFragment() {
        // If the hash fragment is empty, nothing to do
        if (!this.browserService.isCurrentUrlWithHashFragment()) {
            return false;
        }
        let valuesFound = false;
        // Split the hash fragment to obtain the different values that contains
        let hashData = this.browserService.getCurrentUrlHashFragment().split('/');
        // User name is the first element of the hash fragment. If we found a value, 
        // we will fill it automatically
        if (hashData.length > 0) {
            valuesFound = true;
            this.userName = ConversionUtils.base64ToString(hashData[0]);
        }
        // Auto fill the password if it is received
        if (hashData.length > 3) {
            valuesFound = true;
            this.password = ConversionUtils.base64ToString(hashData[3]);
        }
        return valuesFound;
    }
    /**
     * If the current browser URL contains a hash fragment (The part after the # character) that contains encoded user, mail and
     * has verification code values, this method will perform the request to server to verify that email account for the user.
     *
     * The URI path to the mail verification service must be correctly defined at this.mailVerifyServiceURI property.
     *
     * @returns A promise that resolves with the server response if the verification is successful,
     *          or rejects with an error if the verification fails. Response will have 4 possible values:
     *               undefined - meaning that the URL hash fragment didn't contain valid verification values
     *              -1 - meaning verification failed
     *               0 - meaning verification succeeded
     *               1 - meaning the email was already previouly verified
     */
    verifyUserMailFromURLHashFragment() {
        // If the hash fragment is empty, nothing to do
        if (this.browserService.isCurrentUrlWithHashFragment()) {
            let hashData = this.browserService.getCurrentUrlHashFragment().split('/');
            if (hashData.length >= 3) {
                // Call for the user mail verification if user, mail and hash are received
                let user = ConversionUtils.base64ToString(hashData[0]);
                let mail = ConversionUtils.base64ToString(hashData[1]);
                let hash = ConversionUtils.base64ToString(hashData[2]);
                if (!StringUtils.isEmpty(user) && !StringUtils.isEmpty(mail) && !StringUtils.isEmpty(hash)) {
                    this._lastVerifiedMail = mail;
                    return this.call(this.mailVerifyServiceURI, { userName: user, mail: mail, hash: hash });
                }
            }
        }
        return Promise.resolve(undefined);
    }
    /**
     * Obtain the lat user mail account that has been verified (or attempted to verify) by this service.
     */
    getLastVerifiedMail() {
        return this._lastVerifiedMail;
    }
    /**
     * Authenticates the userName and password that are currently defined at the respective properties of this service.
     * Returns a promise that resolves with the server's response or rejects with an error if the login fails.
     * Path to the login service must be correctly defined at this.loginWebService
     *
     * The authentication process is performed by sending an encoded credentials request to the login web service using the
     * currently defined user name and psw.
     *
     * Here's an example of a call:
     *
     *  login().then(response => {
     *     console.log('Login successful:', response);
     *  }).catch(() => {
     *     console.error('Login failed:');
     *  });
     *
     * @returns A promise that resolves with the server response if the login is successful,
     *          or rejects with an error if the login fails.
     */
    login() {
        this.dialogService.addModalBusyState();
        return new Promise((resolve, reject) => {
            const request = new HTTPManagerPostRequest(this.loginServiceURI);
            request.ignoreGlobalPostParams = true;
            const encodedCredentials = ConversionUtils.stringToBase64(ConversionUtils.stringToBase64(this._userName) + ',' + ConversionUtils.stringToBase64(this._password));
            request.parameters = { data: encodedCredentials };
            request.successCallback = (response) => {
                if (response !== '') {
                    response = JSON.parse(response);
                    this._isLogged = true;
                    this._token = response.token;
                    this._operations = response.operations;
                    this.httpManager.setGlobalPostParam('token', response.token);
                    resolve(response);
                }
                else {
                    this._clearUserAndToken();
                    reject(new Error());
                }
            };
            request.errorCallback = () => {
                this._clearUserAndToken();
                reject(new Error());
            };
            request.finallyCallback = () => {
                this.dialogService.removeModalBusyState();
            };
            this.httpManager.execute(request);
        });
    }
    /**
     * Perform a request to the API service to create a new token for the user that is currently logged in.
     *
     * @param options The parameters that will affect the token behaviour. To learn more about each option, please
     *        refer to the turbodepot UsersManager class createToken method documentation
     *
     * @returns A promise that resolves with the created token string if the request is successful, or rejects
     *          with an error (containing all the error response details) if the request fails.
     */
    createUserToken(options) {
        return this.call(this.tokenCreationServiceURI, { options: options }, { resultFormat: 'STRING' });
    }
    /**
     * Checks if the user and password credentials are filled and not empty.
     * If any of the two values is empty, false will be returned
     */
    get isUserAndPswDefined() {
        return !StringUtils.isEmpty(this._userName) && !StringUtils.isEmpty(this._password);
    }
    /**
     * Tells if the user name and psw that are specified on this service are currently logged or not. This means
     * also a token is active.
     */
    get isLogged() {
        return this._isLogged;
    }
    /**
     * Gives the value for the currently active user authentication token or an empty string if no user logged
     */
    get token() {
        return this._token;
    }
    /**
     * Checks if the currently logged user is allowed to perform the specified operation.
     * This will check the user permisions as defined on server side and return true if the operation is allowed
     * or false if not. We can then decide what to do (hide an app section, block a button, etc)
     *
     * @param operation The name of the operation to check
     *
     * @returns True if the operation is allowed, false otherwise
     */
    isUserAllowedTo(operation) {
        return this._operations.includes(operation);
    }
    /**
     * Performs a standard request to an API service and returns a promise that resolves with the response data.
     *
     * Following is an example of a call:
     *
     *     this.apiService.call('users/user-create', this.userData, {handleErrors: false}).then(response => {
     *
     *          console.log('Success:', response);
     *
     *      }).catch(error => {
     *
     *          console.error('Error:', error.message);
     *      });
     *
     * @param apiPath - A relative URL (based on the defined base root url) that defines the path to the service to call.
     *        For example: 'users/login'
     * @param parameters - An object containing key-value pairs that are sent as the request body.
     *        token parameter is not necessary, it is automatically appended
     * @param options An object defining several options for the request:
     *        resultFormat: 'JSON' by default. The expected format of the response.
     *        busyState: Enabled by default. Enables or disables the busy state to lock user interaction while performing the http calls.
     *        handleErrors: Enabled by default. If set to true, an error dialog will be automatically shown when the call fails.
     *        If set to false, the promise will generate a reject error that must be handled by our code.
     *
     * @returns A promise that resolves with the response data correctly parsed if the request is successful, or rejects
     *          with an error (containing all the error response details) if the request fails.
     */
    call(apiPath, parameters = {}, options = {}) {
        // Set the default values for non specified properties
        options.resultFormat = options.resultFormat ?? 'JSON';
        options.busyState = options.busyState ?? true;
        options.handleErrors = options.handleErrors ?? true;
        if (options.busyState) {
            this.dialogService.addModalBusyState();
        }
        return new Promise((resolve, reject) => {
            // Create the request object
            const request = new HTTPManagerPostRequest(apiPath, options.resultFormat === 'STRING' ? HTTPManagerPostRequest.STRING : HTTPManagerPostRequest.JSON);
            request.parameters = parameters;
            request.successCallback = (response) => {
                resolve(response);
            };
            request.errorCallback = (errorMsg, errorCode, response) => {
                if (options.handleErrors) {
                    this.showErrorDialog(errorMsg, errorCode, response);
                }
                else {
                    reject(new Error(errorMsg + ' ' + errorCode + ' ' + response));
                }
            };
            request.finallyCallback = () => {
                if (options.busyState) {
                    this.dialogService.removeModalBusyState();
                }
            };
            this.httpManager.execute(request);
        });
    }
    /**
     * Performs a request to chain several api calls into a single http request, via the chain services mechanism of the turboframework API.
     * Returns a promise that resolves with an array of response objects. One for each of the request calls.
     *
     * @param apiPath - A relative URL (based on the defined base root url) that defines the path to the root of the chain services call.
     *        For example: 'turbosite/chain/chain-services'
     * @param services - An array of objects, were each object contains a valid structure for the chain services call.
     *        Token parameter is not necessary, it is automatically appended
     * @param options An object defining several options for the request:
     *        busyState: Enables or disables the busy state to lock user interaction while performing the http calls. Enabled by default
     *        handleErrors: Enabled by default. If set to true, an error dialog will be automatically shown when the call fails.
     *        If set to false, the promise will generate a reject error that must be handled by our code.
     *
     * @returns A promise that resolves with the response data correctly parsed if the request is successful, or rejects
     *          with an error (containing all the error response details) if the request fails.
     */
    callChain(apiPath, services, options = {}) {
        // Set the default values for non specified properties
        options.busyState = options.busyState ?? true;
        options.handleErrors = options.handleErrors ?? true;
        if (options.busyState) {
            this.dialogService.addModalBusyState();
        }
        return new Promise((resolve, reject) => {
            const request = new HTTPManagerPostRequest(apiPath, HTTPManagerPostRequest.JSON);
            request.ignoreGlobalPostParams = true;
            request.parameters = { services: services };
            request.successCallback = (response) => {
                resolve(response);
            };
            request.errorCallback = (errorMsg, errorCode, response) => {
                if (options.handleErrors) {
                    this.showErrorDialog(errorMsg, errorCode, response);
                }
                else {
                    reject(new Error(errorMsg + ' ' + errorCode + ' ' + response));
                }
            };
            request.finallyCallback = () => {
                if (options.busyState) {
                    this.dialogService.removeModalBusyState();
                }
            };
            this.httpManager.execute(request);
        });
    }
    /**
     * Aux method to show an error dialog when a request fails and error handling is enabled
     */
    showErrorDialog(errorMsg, errorCode, response) {
        errorMsg = errorMsg + '\n\n' + response;
        if (StringUtils.isEmpty(errorMsg)) {
            errorMsg = 'Unknown error. Make sure Internet connection is available';
        }
        this.dialogService.addDialog(DialogErrorComponent, {
            width: '50vw',
            texts: ['Error: ' + errorCode, errorMsg],
            options: ['Ok']
        });
    }
    /**
     * Perform the logout for the currently logged user
     *
     * @param options An object defining several options for the request:
     *        handleErrors: Enabled by default. If set to true, an error dialog will be automatically shown when the call fails.
     *        If set to false, the promise will generate a reject error that must be handled by our code.
     *
     * @returns A promise that resolves correctly if the logout is correct, or rejects with an error (containing all the error
     *          response details) if the request fails.
     */
    logout(options = {}) {
        // Set the default values for non specified properties
        options.handleErrors = options.handleErrors ?? true;
        this.dialogService.addModalBusyState();
        return new Promise((resolve, reject) => {
            const request = new HTTPManagerPostRequest(this.logOutServiceURI);
            request.parameters = { token: this._token };
            request.successCallback = () => {
                this._clearUserAndToken();
                resolve(undefined);
            };
            request.errorCallback = (errorMsg, errorCode, response) => {
                if (options.handleErrors) {
                    this.showErrorDialog(errorMsg, errorCode, response);
                }
                else {
                    reject(new Error(errorMsg + ' ' + errorCode + ' ' + response));
                }
            };
            request.finallyCallback = () => {
                this.dialogService.removeModalBusyState();
            };
            this.httpManager.execute(request);
        });
    }
    /**
     * Aux methot to clear all the currently logged user data
     */
    _clearUserAndToken() {
        this._userName = '';
        this._password = '';
        this._isLogged = false;
        this._token = '';
        this.httpManager.setGlobalPostParam('token', '-');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: TurboApiService, deps: [{ token: DialogService }, { token: BrowserService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: TurboApiService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: TurboApiService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: DialogService }, { type: BrowserService }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Global service that helps with application routing and related functionalities.
 * It is defined as an abstract class so it must be extended in our application to be used.
 * We must declare a static array of routes that will be used to define the routes of the application.
 */
class RouterBaseService {
    constructor(router, titleService) {
        this.router = router;
        this.titleService = titleService;
        /**
         * Indicates whether the title manager has been initialized.
         * This should only be done once, typically at application startup.
         */
        this._isTitleManagerInitialized = false;
        /**
         * BehaviorSubject that holds the current route URL.
         * This allows components to reactively subscribe to route changes.
         */
        this._currentRoute = new BehaviorSubject(this.router.url);
        // Initial update in case the service loads after the first NavigationEnd
        this._updateCurrentRoute();
    }
    /**
     * Updates the current route URL in the BehaviorSubject.
     * This is called internally after each navigation event.
     */
    _updateCurrentRoute() {
        this._currentRoute.next(this.router.url);
    }
    /**
     * Checks if the current route matches the specified route.
     *
     * @param route The route to check against the current route.
     *
     * @returns True if we are actually at the specified route, false otherwise.
     */
    isRouteCurrent(route) {
        return this.getCurrentRoute() === '/' + route;
    }
    /**
     * Gets the current value of the route URL synchronously.
     */
    getCurrentRoute() {
        return this._currentRoute.getValue();
    }
    /**
     * Gets the value of a specific route parameter by its key from the current route.
     *
     * For example, if the current route is `/user/123`, and you call this method with `key` as `id`, it will return `123`.
     * The name of the parameter must match the one defined in the route configuration on your application (e.g., `{ path: 'user/:id', component: UserComponent }`).
     *
     * @param key The key of the route parameter to retrieve.
     *
     * @returns The value of the specified route parameter, or undefined if it does not exist.
     */
    getCurrentRouteParamValue(key) {
        let currentRoute = this.router.routerState.snapshot.root;
        while (currentRoute.firstChild) {
            currentRoute = currentRoute.firstChild;
        }
        if (!(key in currentRoute.params)) {
            throw new Error(`Route parameter '${key}' does not exist.`);
        }
        return currentRoute.params[key];
    }
    /**
     * Initializes the title management feature to automatically refresh the browser title based on the current
     * URL route. It Must be called once, typically at application startup
     *
     * To correctly translate the route title, We expect the route definitions to have the following properties:
     *
     * - titleKey: The key to be used to get the title from the translation bundle.
     * - titleBundle: The bundle to be used to get the title from the translation bundle.
     *
     * (Translations will be done using the LocalesService from this same library).
     *
     * Example of a Route using this feature:
     *   // Home route
     *   { path: '', component: HomePageComponent,
     *     data: { titleKey: 'HOME',  titleBundle: 'turbodepot/user-interface'} },
     *
     * @param prefix A text to be added before the computed title.
     * @param sufix A text to be added after the computed title.
     */
    initializeAutoTranslateTitleByRoute(localesService, prefix = '', sufix = '') {
        this._localesService = localesService;
        if (this._isTitleManagerInitialized) {
            throw new Error('Title refresh from routes has already been initialized. Can only be done once.');
        }
        // Set initial title based on current route data immediately
        this.updateTitleFromCurrentRoute(prefix, sufix);
        // Subscribe to future navigation events
        this._routerSubscription = this.router.events.pipe(filter(event => event instanceof NavigationEnd)).subscribe(() => {
            this._updateCurrentRoute();
            this.updateTitleFromCurrentRoute(prefix, sufix);
        });
        this._isTitleManagerInitialized = true;
    }
    /**
     * Aux method: Updates the browser title based on the current route's data properties.
     * This is called after each navigation event to ensure the title is always up-to-date.
     *
     * @param prefix A text to be added before the computed title.
     * @param sufix A text to be added after the computed title.
     */
    updateTitleFromCurrentRoute(prefix, sufix) {
        let currentRoute = this.router.routerState.snapshot.root;
        while (currentRoute.firstChild) {
            currentRoute = currentRoute.firstChild;
        }
        const data = currentRoute.data;
        if (data['titleKey'] && data['titleBundle']) {
            this.titleService.setTitle(prefix + this._localesService.t(data['titleKey'], data['titleBundle']) + sufix);
        }
    }
    /**
     * Navigates to the specified route.
     *
     * @param route The route to navigate to.
     */
    navigateTo(route) {
        this.router.navigate(['/' + route]);
    }
    ngOnDestroy() {
        this._routerSubscription?.unsubscribe();
        // Clean up BehaviorSubject
        this._currentRoute.complete();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: RouterBaseService, deps: [{ token: i1$2.Router }, { token: i2$2.Title }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: RouterBaseService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: RouterBaseService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: i1$2.Router }, { type: i2$2.Title }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Fully featured translation manager to be used with any application that requires text internationalization.
 * It is defined as an abstract class so it must be extended in our application. This way we can
 * write custom methods to extend the functionality of this class if needed.
 */
class LocalesBaseService {
    constructor() {
        /**
         * if the class has been correctly initialized and translations have been correctly loaded
         */
        this._isInitialized = false;
        /**
         * @see getLocales()
         */
        this._locales = [];
        /**
         * @see getLanguages()
         */
        this._languages = [];
        /**
         * Stores all the loaded localization data by library name, bundle name, key and locales
         */
        this._loadedTranslations = {};
        /**
         * Stores a memory cache to improve performance when outputing translations
         */
        this._keyValuesCache = {};
        /**
         * @see setWildCardsFormat()
         */
        this._wildCardsFormat = '{N}';
        /**
         * @see setMissingKeyFormat()
         */
        this._missingKeyFormat = '$exception';
        /**
         * Stores a hash value that is used to improve the performance for translation t() methods.
         * This is computed based on _wildCardsFormat plus _missingKeyFormat plus the current primary locale
         * Methods that change these values will recalculate the hash string, so when calling translation methods, the
         * performance will be as fast as possible.
         */
        this._cacheHashBaseString = '';
    }
    /**
     * Wildcards are string fragments that are placed inside the translated texts. Their main purpose is to be replaced at
     * runtime by custom values like for example a user name, a date, a numeric value, etc..
     *
     * This class helps with this process by including a parameter called 'toReplace' on all ->t methods which allows us
     * to specify a string or list of strings that will replace the respective wildcards on the translated text. Each wildcard
     * must follow the format specified here, and contain a numeric digit that will be used to find the replacement text at the
     * 'toReplace' list. For example, if we define $N as the wildcard format, and we have a translation that contains $0, $1, $2,
     * $0 will be replaced with the first element on toReplace, $1 with the second and so.
     *
     * We usually set this before initializing the class translation data
     *
     * Notice that N is mandayory on the wildcards format and the first index value is 0.
     *
     * @param value The wildcards format we want to set
     *
     * @returns The value that's been set
     */
    setWildCardsFormat(value) {
        if (!value.includes('N')) {
            throw new Error("N is mandatory to replace wildcards");
        }
        this._cacheHashBaseString = value + this._missingKeyFormat + ((this._locales.length > 0) ? this._locales[0] : '');
        this._wildCardsFormat = value;
        return value;
    }
    /**
     * Defines the behaviour for t(), tStartCase(), etc... methods when a key is not found on
     * a bundle or the bundle does not exist
     *
     * If missingKeyFormat is an empty string, all missing keys will return an empty value (not recommended)
     *
     * If missingKeyFormat contains a string, that string will be always returned for missing keys
     *
     * If missingKeyFormat contains a string with one of the following predefined wildcards:<br>
     *    - $key will be replaced with key name. Example: get("NAME") will output [NAME] if key is not found and missingKeyFormat = '[$key]'<br>
     *    - $exception (default value) will throw an exception with the problem cause description.
     *
     * @param value The missing key format we want to set
     *
     * @returns The value that's been set
     */
    setMissingKeyFormat(value) {
        this._cacheHashBaseString = this._wildCardsFormat + value + ((this._locales.length > 0) ? this._locales[0] : '');
        this._missingKeyFormat = value;
        return value;
    }
    /**
     * @see setMissingKeyFormat()
     */
    getMissingKeyFormat() {
        return this._missingKeyFormat;
    }
    /**
     * Adds translations to the class by loading and parsing bundles from the provided JSON object.
     * After the method finishes, the class will contain all the translation data and will be ready to translate
     * any provided key to any of the specified locales.
     *
     * @param locales An array of locale codes (e.g., ['en_US', 'es_ES', 'fr_FR']) to load from the json data into this class.
     *        The order of this array will determine the priority when looking for translations.
     *
     * @param json A JSON object containing the translation data. The structure must be as follows:
     *       { library_name: { bundle_name: { locale_code: { key1: "translation1", key2: "translation2" } } } ... }
     *
     * @return True if the translations get correctly loaded. Any unsuccessful initialization will throw an exception
     */
    loadLocalesFromJson(locales, json) {
        this._isInitialized = false;
        // Validate received locales are correct
        for (const locale of locales) {
            this._validateLocaleString(locale);
        }
        // Validate the translations object follows the right structure
        let isTranslationsValid = false;
        for (const library in json) {
            for (const bundle in json[library]) {
                for (const locale in json[library][bundle]) {
                    this._validateLocaleString(locale);
                    isTranslationsValid = true;
                }
            }
        }
        if (!isTranslationsValid) {
            throw new Error('translations must be a non empty object with the structure: { library: { bundle: { xx_XX: { key: translation } } } }');
        }
        this._loadedTranslations = json;
        this._locales = locales;
        this._languages = locales.map((l) => l.substring(0, 2));
        this._cacheHashBaseString = this._wildCardsFormat + this._missingKeyFormat + this._locales[0];
        this._isInitialized = true;
        return true;
    }
    /**
     * Initializes the translation system by loading and parsing bundle files from the specified translations path.
     * After the promise finishes, the class will contain all the translation data and will be ready to translate any
     * provided key.
     *
     * @param locales An array of locale codes (['en_US', 'es_ES', 'fr_FR', ...]) to load from the url response.
     *        The order of this array will determine the translation priority
     * @param url - Url where the translations are found. The response must be a Json with the expected structure:
     *              { library_name: { bundle_name: { locale_code: { key1: "translation1", key2: "translation2" } } } ... }
     *
     * @return A promise that will resolve if the translations get correctly loaded, or reject with an error if load fails
     */
    loadLocalesFromUrl(locales, url) {
        this._isInitialized = false;
        return new Promise((resolve, reject) => {
            fetch(url).then(response => {
                if (!response.ok) {
                    throw new Error(`HTTP error! status: ${response.status}`);
                }
                return response.json();
            }).then(data => {
                this.loadLocalesFromJson(locales, data);
                resolve(undefined);
            }).catch(error => {
                reject(new Error(`ERROR LOADING LOCALES FROM: ${url}\n` + error));
            });
        });
    }
    /**
     * Check if the class has been correctly initialized and translations have been correctly loaded
     */
    isInitialized() {
        return this._isInitialized;
    }
    /**
     * Aux method to verify that this class is correctly initialized with translation data
     */
    _validateInitialized() {
        if (!this._isInitialized) {
            throw new Error('Translation service not initialized');
        }
    }
    /**
     * Checks if the specified locale is currently loaded for the currently defined bundles and paths.
     *
     * @param locale A locale to check. For example 'en_US'
     *
     * @return True if the locale is currently loaded on the class, false if not.
     */
    isLocaleLoaded(locale) {
        this._validateLocaleString(locale);
        return this._locales.includes(locale);
    }
    /**
     * Aux method to validate that a locale string is correctly formatted
     *
     * @param string $locale A locale string
     */
    _validateLocaleString(locale) {
        if (!/^[a-z]{2}_[A-Z]{2}$/.test(locale)) {
            throw new Error('locale must be a valid xx_XX value');
        }
    }
    /**
     * Checks if the specified 2 digit language is currently loaded for the currently defined bundles and paths.
     *
     * @param language A language to check. For example 'en'
     *
     * @return True if the language is currently loaded on the class, false if not.
     */
    isLanguageLoaded(language) {
        this._validateLanguageString(language);
        return this._languages.includes(language);
    }
    /**
     * Aux method to validate that a language string is correctly formatted
     *
     * @param language A 2 digit language string
     */
    _validateLanguageString(language) {
        if (!/^[a-z]{2}$/.test(language)) {
            throw new Error('language must be a valid 2 digit value');
        }
    }
    /**
     * Get the translation to the current primary locale for the given key, library and bundle
     *
     * @param string key The key we want to read from the specified resource bundle
     * @param string bundlePath A string with the format 'library_name/bundle_name' that is used to locate the bundle were the key to translate is found
     * @param array replaceWildcards A list of values that will replace wildcards that may be found on the translated text. Each wildcard
     *        will be replaced with the element whose index on replaceWildcards matches it. Check the documentation for this.wildCardsFormat
     *        property to know more about how to setup wildcards on your translations.
     *
     * @see setWildCardsFormat()
     *
     * @return The translated text
     */
    t(key, bundlePath, replaceWildcards = []) {
        this._validateInitialized();
        // Create a cache key to improve performance when requesting the same key translation several times
        const cacheKey = `${this._cacheHashBaseString}${key}${bundlePath}${replaceWildcards.join('')}`;
        if (!this._keyValuesCache[cacheKey]) {
            this._forceNonEmptyString(key, '', 'key must be non empty string');
            this._forceNonEmptyString(bundlePath, '', 'bundlePath must be non empty string');
            const [library, bundle] = bundlePath.split('/');
            this._forceNonEmptyString(library, '', 'no library specified on bundlePath');
            this._forceNonEmptyString(bundle, '', 'no bundle specified on bundlePath');
            const replacementsCount = replaceWildcards.length;
            // Loop all the locales to find the first one with a value for the specified key
            for (const locale of this._locales) {
                if (this._loadedTranslations[library]?.[bundle]?.[locale]?.[key]) {
                    let result = this._loadedTranslations[library][bundle][locale][key];
                    // Replace all wildcards on the text with the specified replacements if any
                    for (let i = 0; i < replacementsCount; i++) {
                        result = this._replace(result, this._replace(this._wildCardsFormat, 'N', i.toString()), replaceWildcards[i]);
                    }
                    this._keyValuesCache[cacheKey] = result;
                    return result;
                }
            }
            // Check if an exception needs to be thrown if the specified key is not found on this bundle
            if (this._missingKeyFormat.includes('$exception')) {
                throw new Error(`Translation key <${key}> not found on <${bundlePath}>`);
            }
            this._keyValuesCache[cacheKey] = this._replace(this._missingKeyFormat, '$key', key);
        }
        return this._keyValuesCache[cacheKey];
    }
    /**
     * Get the translation for the given key and bundle as a string with all words first character capitalized
     * and all the rest of the word with lower case
     *
     * @see t()
     *
     * @returns The localized and case formatted text
     */
    tStartCase(key, bundlePath, replaceWildcards = []) {
        return this.t(key, bundlePath, replaceWildcards).split(' ')
            .map((word) => word ? word[0].toUpperCase() + word.slice(1).toLowerCase() : '').join(' ');
    }
    /**
     * Get the translation for the given key and bundle as an all upper case string
     *
     * @see t()
     *
     * @returns The localized and case formatted text
     */
    tAllUpperCase(key, bundlePath, replaceWildcards = []) {
        return this.t(key, bundlePath, replaceWildcards).toUpperCase();
    }
    /**
     * Get the translation for the given key and bundle as an all lower case string
     *
     * @see t()
     *
     * @returns The localized and case formatted text
     */
    tAllLowerCase(key, bundlePath, replaceWildcards = []) {
        return this.t(key, bundlePath, replaceWildcards).toLowerCase();
    }
    /**
     * Get the translation for the given key and bundle as a string with the first character as Upper case
     * and all the rest as lower case
     *
     * @see t()
     *
     * @returns The localized and case formatted text
     */
    tFirstUpperRestLower(key, bundlePath, replaceWildcards = []) {
        const string = this.t(key, bundlePath, replaceWildcards);
        return string.charAt(0).toUpperCase() + string.slice(1).toLowerCase();
    }
    /**
     * A list of strings containing the locales that are used by this class to translate the given keys, sorted by preference.
     * Each string is formatted as a standard locale code with language and country joined by an underscore, like: en_US, fr_FR
     *
     * When a key and bundle are requested for translation, the class will check on the first language of this
     * list for a translated text. If missing, the next one will be used, and so. This list is constructed after initialize
     * methods is called.
     *
     * @example: After loading the following list of locales ['en_US', 'es_ES', 'fr_FR'] if we call t('HELLO', 'lib1/greetings')
     * the localization manager will try to locate the en_US value for the HELLO tag on the greetings bundle for the library lib1.
     * If the tag is not found for the specified locale and bundle, the same search will be performed for the es_ES locale, and so, till a
     * value is found or no more locales are defined.
     */
    getLocales() {
        return this._locales;
    }
    /**
     * A list of strings containing the languages that are used by this class to translate the given keys, sorted by preference.
     * Each string is formatted as a 2 digit language code, like: en, fr
     *
     * This list is the same as the locales() one, but containing only the language part of each locale (the first two digits)
     *
     * @see getLocales()
     */
    getLanguages() {
        return this._languages;
    }
    /**
     * Get the first locale from the list of loaded locales, which is the currently used to search for translated texts.
     *
     * @returns The locale that is defined as the primary one. For example: en_US, es_ES, ..
     */
    getPrimaryLocale() {
        this._validateInitialized();
        return this._locales[0];
    }
    /**
     * Get the first language from the list of loaded locales, which is the currently used to search for translated texts.
     *
     * @returns The 2 digit language code that is defined as the primary one. For example: en, es, ..
     */
    getPrimaryLanguage() {
        this._validateInitialized();
        return this._languages[0];
    }
    /**
     * Define the locale that will be placed at the front of the currently loaded locales list (moving all the others one position to the right).
     *
     * This will be the first locale to use when trying to get a translation.
     *
     * @param locale A currently loaded locale that will be moved to the first position of the loaded locales list. If the specified locale
     *        is not currently loaded, an exception will happen.
     *
     * @returns void
     */
    setPrimaryLocale(locale) {
        this._validateInitialized();
        if (!this.isLocaleLoaded(locale)) {
            throw new Error(locale + ' not loaded');
        }
        let result = [locale];
        for (let l of this._locales) {
            if (l !== locale) {
                result.push(l);
            }
        }
        this._locales = result;
        this._languages = this._locales.map((l) => l.substring(0, 2));
        this._cacheHashBaseString = this._wildCardsFormat + this._missingKeyFormat + this._locales[0];
    }
    /**
     * Moves the specified locales to the beginning of the locales list. This also alters the translation priority by setting the first
     * provided locale as the most prioritary, the second as the next one and so.
     *
     * This method basically works exactly the same way as setPrimaryLocale but letting us add many locales at once.
     *
     * @see setPrimaryLocale()
     *
     * @param locales A list of locales to be moved to the beginning of the translation priority. First locales item will be the prefered
     *        locale for translation, second will be the next one in case some key is not translated for the first one and so. If any of the
     *        specified locales is not currently loaded, an exception will happen.
     *
     * @returns void
     */
    setPrimaryLocales(locales) {
        if (!Array.isArray(locales) ||
            (new Set(locales).size !== locales.length) ||
            locales.length === 0) {
            throw new Error('locales must be non empty string array with no duplicate elements');
        }
        for (let i = locales.length - 1; i >= 0; i--) {
            this.setPrimaryLocale(locales[i]);
        }
    }
    /**
     * Define the 2 digit language that will be placed at the front of the currently loaded locales list (moving all the others one position to the right).
     *
     * This will be the first language to use when trying to get a translation.
     *
     * @param language A 2 digit language code that matches with any of the currently loaded locales, which will
     *        be moved to the first position of the loaded locales list. If the specified language does not match with
     *        a locale that is currently loaded, an exception will happen.
     *
     * @returns void
     */
    setPrimaryLanguage(language) {
        for (let locale of this._locales) {
            if (locale.substring(0, 2) === language) {
                this.setPrimaryLocale(locale);
                return;
            }
        }
        throw new Error(language + ' not loaded');
    }
    /**
     * Moves the locales that match the specified languages to the beginning of the locales list.
     * Works the same as setPrimaryLocales() but with a list of the 2 digit language codes that match the respective locales.
     *
     * @see setPrimaryLocale()
     * @see setPrimaryLanguage()
     *
     * @param languages A list of 2 digit language codes to be moved to the beginning of the translation priority. If any of the
     *        specified languages does not match with a locale that is currently loaded, an exception will happen.
     *
     * @returns void
     */
    setPrimaryLanguages(languages) {
        if (!Array.isArray(languages) ||
            (new Set(languages).size !== languages.length) ||
            languages.length === 0) {
            throw new Error('languages must be non empty string array with no duplicate elements');
        }
        for (let i = languages.length - 1; i >= 0; i--) {
            this.setPrimaryLanguage(languages[i]);
        }
    }
    /**
     * Change the loaded locales translation preference order. The same locales that are currently loaded must be passed
     * but with a different order to change the translation priority.
     *
     * @param locales A list with the new locales translation priority
     *
     * @returns void
     */
    setLocalesOrder(locales) {
        if (locales.length !== this._locales.length) {
            throw new Error('locales must contain all the currently loaded locales');
        }
        this._validateInitialized();
        for (let locale of locales) {
            if (!this.isLocaleLoaded(locale)) {
                throw new Error(locale + ' not loaded');
            }
        }
        this._locales = locales;
        this._languages = this._locales.map((l) => l.substring(0, 2));
        this._cacheHashBaseString = this._wildCardsFormat + this._missingKeyFormat + this._locales[0];
    }
    /**
     * This is an aux method to implement the TurboCommons StringUtils replace method.
     * It is exactly the same as the one on the library, but we implement it here to avoid having a dependency with TurboCommons
     */
    _replace(string, search, replacement) {
        const escapedSearch = search.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
        return string.replace(new RegExp(escapedSearch, 'g'), replacement);
    }
    /**
     * This is an aux method to implement the TurboCommons StringUtils isEmpty method.
     * It is exactly the same as the one on the library, but we implement it here to avoid having a dependency with TurboCommons
     */
    _isEmpty(string) {
        let isString = (typeof string === 'string' || string instanceof String);
        // Throw exception if non string value was received
        if (!isString) {
            // Empty or null value is considered empty
            if (string == null || string == '') {
                return true;
            }
            throw new Error("value is not a string");
        }
        return string.replace(/[ \n\r\t]/g, '') === '';
    }
    /**
     * This is an aux method to implement the TurboCommons StringUtils forceNonEmptyString method.
     * It is exactly the same as the one on the library, but we implement it here to avoid having a dependency with TurboCommons
     */
    _forceNonEmptyString(value, valueName = '', errorMessage = 'must be a non empty string') {
        let isString = (typeof value === 'string' || value instanceof String);
        if (!isString || this._isEmpty(value)) {
            throw new Error(valueName + ' ' + errorMessage);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: LocalesBaseService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: LocalesBaseService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: LocalesBaseService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * A dialog component with an iframe that can be used to display any url or content.
 *
 * We must specify the url in the data parameter when opening the dialog, and we can also specify the title
 * bi placing it at the first position of the texts array.
 */
class DialogIFrameComponent extends DialogBaseComponent {
    static { this.DIALOG_CLASS_NAME = 'DialogIFrameComponent'; }
    constructor(elementRef, dialogRef, sanitizer, data) {
        super(elementRef, dialogRef);
        this.elementRef = elementRef;
        this.dialogRef = dialogRef;
        this.sanitizer = sanitizer;
        this.data = data;
        this.title = '';
        if (data.texts.length > 0) {
            this.title = data.texts[0];
        }
        this.safeUrl = this.sanitizer.bypassSecurityTrustResourceUrl(data.data);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogIFrameComponent, deps: [{ token: i0.ElementRef }, { token: i1.MatDialogRef }, { token: i2$2.DomSanitizer }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: DialogIFrameComponent, isStandalone: true, selector: "tg-dialog-iframe", providers: [], usesInheritance: true, ngImport: i0, template: "<h2 *ngIf=\"title !== ''\">{{title}}</h2>\r\n\r\n<iframe [src]=\"safeUrl\" title=\"data.texts[0]\"></iframe>", styles: [":host{display:block;width:100%;height:100%}h2{margin-top:0;margin-bottom:25px;width:82%}iframe{width:100%;height:100%}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogIFrameComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tg-dialog-iframe', imports: [CommonModule], providers: [], template: "<h2 *ngIf=\"title !== ''\">{{title}}</h2>\r\n\r\n<iframe [src]=\"safeUrl\" title=\"data.texts[0]\"></iframe>", styles: [":host{display:block;width:100%;height:100%}h2{margin-top:0;margin-bottom:25px;width:82%}iframe{width:100%;height:100%}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1.MatDialogRef }, { type: i2$2.DomSanitizer }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * A dialog component with a single option button, to be used with dialog service
 */
class DialogSingleOptionComponent extends DialogBaseComponent {
    static { this.DIALOG_CLASS_NAME = 'DialogSingleOptionComponent'; }
    constructor(elementRef, dialogRef, data) {
        super(elementRef, dialogRef);
        this.elementRef = elementRef;
        this.dialogRef = dialogRef;
        this.data = data;
        if (data.texts.length < 1) {
            throw new Error('DialogSingleOptionComponent expects 2 texts: The title and optionally a description');
        }
        if (data.options.length !== 1) {
            throw new Error('DialogSingleOptionComponent expects only one option');
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogSingleOptionComponent, deps: [{ token: i0.ElementRef }, { token: i1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: DialogSingleOptionComponent, isStandalone: true, selector: "tg-dialog-single-option", providers: [], usesInheritance: true, ngImport: i0, template: "<h3>\r\n    {{data.texts[0]}}\r\n</h3>\r\n\r\n<p *ngIf=\"data.texts.length > 1\">\r\n    {{data.texts[1]}}\r\n</p>\r\n\r\n<button mat-raised-button color=\"primary\"\r\n    (click)=\"closeDialog(0)\">\r\n    \r\n    {{data.options[0]}}\r\n    \r\n</button>", styles: [":host{min-height:300px}h3{margin-bottom:25px}p{margin-bottom:52px}button{float:right}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogSingleOptionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tg-dialog-single-option', imports: [CommonModule, MatButtonModule], providers: [], template: "<h3>\r\n    {{data.texts[0]}}\r\n</h3>\r\n\r\n<p *ngIf=\"data.texts.length > 1\">\r\n    {{data.texts[1]}}\r\n</p>\r\n\r\n<button mat-raised-button color=\"primary\"\r\n    (click)=\"closeDialog(0)\">\r\n    \r\n    {{data.options[0]}}\r\n    \r\n</button>", styles: [":host{min-height:300px}h3{margin-bottom:25px}p{margin-bottom:52px}button{float:right}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * A dialog component with two option buttons, to be used with dialog service.
 * The first of the options is considered to be the primary one and will therefore have more visual accent
 */
class DialogTwoOptionComponent extends DialogBaseComponent {
    static { this.DIALOG_CLASS_NAME = 'DialogTwoOptionComponent'; }
    constructor(elementRef, dialogRef, data) {
        super(elementRef, dialogRef);
        this.elementRef = elementRef;
        this.dialogRef = dialogRef;
        this.data = data;
        if (data.texts.length < 1) {
            throw new Error('DialogTwoOptionComponent expects 2 texts: The title and optionally a description');
        }
        if (data.options.length !== 2) {
            throw new Error('DialogTwoOptionComponent expects only two options');
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogTwoOptionComponent, deps: [{ token: i0.ElementRef }, { token: i1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: DialogTwoOptionComponent, isStandalone: true, selector: "tg-dialog-two-option", providers: [], usesInheritance: true, ngImport: i0, template: "<h3>\r\n    {{data.texts[0]}}\r\n</h3>\r\n\r\n<p *ngIf=\"data.texts.length > 1\">\r\n    {{data.texts[1]}}\r\n</p>\r\n\r\n<div class=\"buttonsContainer\">\r\n\r\n    <button mat-raised-button color=\"primary\" class=\"primaryButton\"\r\n        (click)=\"closeDialog(0)\">\r\n        \r\n        {{data.options[0]}}\r\n        \r\n    </button>\r\n    \r\n    <button mat-button\r\n        (click)=\"closeDialog(1)\">\r\n        \r\n        {{data.options[1]}}\r\n        \r\n    </button>\r\n    \r\n</div>\r\n", styles: [":host{min-height:300px}h3{margin-bottom:25px}p{margin-bottom:52px}.buttonsContainer{width:100%;max-width:530px;display:flex;flex-direction:row-reverse;float:right}button{width:50%;padding:0}.primaryButton{margin-left:2%}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogTwoOptionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tg-dialog-two-option', imports: [CommonModule, MatButtonModule], providers: [], template: "<h3>\r\n    {{data.texts[0]}}\r\n</h3>\r\n\r\n<p *ngIf=\"data.texts.length > 1\">\r\n    {{data.texts[1]}}\r\n</p>\r\n\r\n<div class=\"buttonsContainer\">\r\n\r\n    <button mat-raised-button color=\"primary\" class=\"primaryButton\"\r\n        (click)=\"closeDialog(0)\">\r\n        \r\n        {{data.options[0]}}\r\n        \r\n    </button>\r\n    \r\n    <button mat-button\r\n        (click)=\"closeDialog(1)\">\r\n        \r\n        {{data.options[1]}}\r\n        \r\n    </button>\r\n    \r\n</div>\r\n", styles: [":host{min-height:300px}h3{margin-bottom:25px}p{margin-bottom:52px}.buttonsContainer{width:100%;max-width:530px;display:flex;flex-direction:row-reverse;float:right}button{width:50%;padding:0}.primaryButton{margin-left:2%}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * A dialog component that is designed to show more than one option buttons (usually more than two), to be used with dialog service
 */
class DialogMultipleOptionComponent extends DialogBaseComponent {
    static { this.DIALOG_CLASS_NAME = 'DialogMultipleOptionComponent'; }
    constructor(elementRef, dialogRef, data) {
        super(elementRef, dialogRef);
        this.elementRef = elementRef;
        this.dialogRef = dialogRef;
        this.data = data;
        if (data.texts.length < 1) {
            throw new Error('DialogMultipleOptionComponent expects 2 texts: The title and optionally a description');
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogMultipleOptionComponent, deps: [{ token: i0.ElementRef }, { token: i1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: DialogMultipleOptionComponent, isStandalone: true, selector: "tg-dialog-multiple-option", providers: [], usesInheritance: true, ngImport: i0, template: "<h3>\r\n    {{data.texts[0]}}\r\n</h3>\r\n\r\n<p *ngIf=\"data.texts.length > 1\">\r\n    {{data.texts[1]}}\r\n</p>\r\n\r\n<button mat-raised-button color=\"primary\"\r\n    *ngFor=\"let option of data.options; let i = index\"\r\n    (click)=\"closeDialog(i)\">\r\n    \r\n    {{option}}\r\n    \r\n</button>", styles: [":host{display:flex;flex-direction:column;min-height:193px}h3{margin-bottom:45px}button{margin-bottom:25px}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogMultipleOptionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tg-dialog-multiple-option', imports: [CommonModule, MatButtonModule], providers: [], template: "<h3>\r\n    {{data.texts[0]}}\r\n</h3>\r\n\r\n<p *ngIf=\"data.texts.length > 1\">\r\n    {{data.texts[1]}}\r\n</p>\r\n\r\n<button mat-raised-button color=\"primary\"\r\n    *ngFor=\"let option of data.options; let i = index\"\r\n    (click)=\"closeDialog(i)\">\r\n    \r\n    {{option}}\r\n    \r\n</button>", styles: [":host{display:flex;flex-direction:column;min-height:193px}h3{margin-bottom:45px}button{margin-bottom:25px}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * A dialog component which allows us to select one single item from a list. The elements on that list are displayed on a table
 * which may show a scroll if necessary when there are many elements on the list.
 *
 * It also allows us to filter inside the list with a custom text that we can type into a search input, which is optional.
 *
 * texts parameter must contain the title, the description (optional), the filter input title (optional), and the submit button caption.
 * If that caption is not provided, the selection will be automatically performed once user clicks on an element on the list. Otherwise,
 * the element will be selected on the list and the selection will be performed once the user clicks on the submit button.
 *
 * options parameter must contain the list of elements that will be displayed to the user
 */
class DialogSingleSelectionListComponent extends DialogBaseComponent {
    static { this.DIALOG_CLASS_NAME = 'DialogSingleSelectionListComponent'; }
    constructor(elementRef, dialogRef, browserService, data) {
        super(elementRef, dialogRef);
        this.elementRef = elementRef;
        this.dialogRef = dialogRef;
        this.browserService = browserService;
        this.data = data;
        /**
         * Declare a reference to the string utils class so it can be used on the html part
         */
        this.stringUtils = StringUtils;
        /**
         * Contains the list of elements that will be directly shown to the user at the component list.
         * It may be filtered or not depending on this component setup and the user input
         */
        this.filteredOptions = [];
        /**
         * Stores the number of options that are currently visible to the user
         */
        this.filteredOptionsCount = 0;
        /**
         * Contains the original list of elements that are provided to be listed on this component before
         * being possibly filtered. It is only used as a backup, not shown to the user
         */
        this.originalOptions = [];
        /**
         * The same list as the originally provided but processed for a better text search.
         * It will be used to perform the search, but not shown to the user.
         */
        this.originalOptionsFullTextSearch = [];
        /**
         * Stores the index for the element that's been selected by the user
         */
        this.selectedItemIndex = -1;
        /**
         * This method is used to greatly improve ngFor performance with arrays of primitive values. It tells the refresh
         * function to work by index instead of by value. The change in performance when refreshing the list is massive.
         */
        this.trackByFn = (index, _value) => index;
        if (data.texts.length < 1) {
            throw new Error('DialogSingleSelectionListComponent expects 4 texts: The title, the description (optional), the filter input title (optional), and the submit button caption');
        }
        if (data.options.length < 1) {
            throw new Error('DialogSingleSelectionListComponent expects one or more options');
        }
        this.originalOptions = data.options;
        this.filteredOptionsCount = this.originalOptions.length;
        for (let option of this.originalOptions) {
            this.filteredOptions.push(option);
            this.originalOptionsFullTextSearch.push(StringUtils.formatForFullTextSearch(option));
        }
    }
    /**
     * Method to calculate the max possible height that the list items container is allowed to have
     */
    getListItemsContainerMaxheight() {
        return (this.browserService.getWindowHeight() * 0.6) + 'px';
    }
    /**
     * If the user presses enter key and there's only one element filtered in the list, we will close this dialog
     * setting that element as the selected.
     */
    onIntroKeyPress() {
        if (this.filteredOptionsCount === 1) {
            for (let i = 0; i < this.originalOptionsFullTextSearch.length; i++) {
                if (this.filteredOptions[i] !== '') {
                    this.closeDialog(i);
                    return;
                }
            }
        }
    }
    /**
     * When the user types a value on the input element to filter the list, this method will perform
     * that filtering and refresh the list
     */
    onSearchChange(input) {
        this.selectedItemIndex = -1;
        this.filteredOptionsCount = 0;
        let inputValue = StringUtils.formatForFullTextSearch(input.value);
        for (let i = 0; i < this.originalOptionsFullTextSearch.length; i++) {
            if (inputValue === '' ||
                this.originalOptionsFullTextSearch[i].indexOf(inputValue) >= 0) {
                this.filteredOptions[i] = this.originalOptions[i];
                this.filteredOptionsCount++;
            }
            else {
                this.filteredOptions[i] = '';
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogSingleSelectionListComponent, deps: [{ token: i0.ElementRef }, { token: i1.MatDialogRef }, { token: BrowserService }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: DialogSingleSelectionListComponent, isStandalone: true, selector: "tg-dialog-single-selection-list", providers: [], usesInheritance: true, ngImport: i0, template: "<h3>\r\n    {{data.texts[0]}}\r\n</h3>\r\n\r\n<!-- Here goes the dialog subtitle. Leave it blank if you don't need it -->\r\n<p *ngIf=\"data.texts.length > 1 &amp;&amp; !stringUtils.isEmpty(data.texts[1])\">\r\n    {{data.texts[1]}}\r\n</p>\r\n\r\n<mat-form-field *ngIf=\"data.texts.length > 2 &amp;&amp; !stringUtils.isEmpty(data.texts[2])\"\r\n    class=\"searchItemInputContainer\">\r\n    \r\n    <mat-label>{{data.texts[2]}}</mat-label>\r\n    <input matInput autoFocusOnDisplay\r\n        (keyup.enter)=\"onIntroKeyPress()\"\r\n        (input)=\"onSearchChange($event.target)\">\r\n        \r\n</mat-form-field>\r\n\r\n<!-- here goes the list of elements that will be shown to the user -->\r\n<div class=\"listItemsContainer\"\r\n    [style.max-height]=\"getListItemsContainerMaxheight()\">\r\n\r\n    <div class=\"listItemContainer\"\r\n        [style.background-color]=\"selectedItemIndex === i ? '#90d1ffad' : (i % 2 === 0 ? 'initial' : '#00000009')\"\r\n        *ngFor=\"let item of filteredOptions; let i = index; trackBy: trackByFn\"\r\n        (click)=\"data.texts.length < 4 ? closeDialog(i) : selectedItemIndex = i\">\r\n    \r\n        <p *ngIf=\"item !== ''\">\r\n            {{item}}\r\n        </p>\r\n    \r\n    </div>\r\n\r\n</div>\r\n\r\n<button mat-raised-button color=\"primary\"\r\n    [disabled]=\"selectedItemIndex < 0\"\r\n    (click)=\"closeDialog(selectedItemIndex)\"\r\n    *ngIf=\"data.texts.length > 3\">\r\n\r\n    {{data.texts[3]}}\r\n    \r\n</button>", styles: [":host{min-height:300px}h3{margin-top:0;margin-bottom:10px}p{margin-top:0;margin-bottom:5px}.searchItemInputContainer{width:100%;margin-top:0;margin-bottom:0}.listItemsContainer{overflow-y:auto;border:1px solid rgba(0,0,0,.2);border-radius:4px;margin-bottom:5px}.listItemContainer p{line-height:36px;width:calc(100% - 12px);margin:0 0 0 6px}button{float:right}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i4.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatLabel, selector: "mat-label" }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "ngmodule", type: TurboGuiAngularModule }, { kind: "directive", type: AutoFocusOnDisplayDirective, selector: "[autoFocusOnDisplay]" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogSingleSelectionListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tg-dialog-single-selection-list', imports: [CommonModule, MatInputModule, MatFormFieldModule, TurboGuiAngularModule], providers: [], template: "<h3>\r\n    {{data.texts[0]}}\r\n</h3>\r\n\r\n<!-- Here goes the dialog subtitle. Leave it blank if you don't need it -->\r\n<p *ngIf=\"data.texts.length > 1 &amp;&amp; !stringUtils.isEmpty(data.texts[1])\">\r\n    {{data.texts[1]}}\r\n</p>\r\n\r\n<mat-form-field *ngIf=\"data.texts.length > 2 &amp;&amp; !stringUtils.isEmpty(data.texts[2])\"\r\n    class=\"searchItemInputContainer\">\r\n    \r\n    <mat-label>{{data.texts[2]}}</mat-label>\r\n    <input matInput autoFocusOnDisplay\r\n        (keyup.enter)=\"onIntroKeyPress()\"\r\n        (input)=\"onSearchChange($event.target)\">\r\n        \r\n</mat-form-field>\r\n\r\n<!-- here goes the list of elements that will be shown to the user -->\r\n<div class=\"listItemsContainer\"\r\n    [style.max-height]=\"getListItemsContainerMaxheight()\">\r\n\r\n    <div class=\"listItemContainer\"\r\n        [style.background-color]=\"selectedItemIndex === i ? '#90d1ffad' : (i % 2 === 0 ? 'initial' : '#00000009')\"\r\n        *ngFor=\"let item of filteredOptions; let i = index; trackBy: trackByFn\"\r\n        (click)=\"data.texts.length < 4 ? closeDialog(i) : selectedItemIndex = i\">\r\n    \r\n        <p *ngIf=\"item !== ''\">\r\n            {{item}}\r\n        </p>\r\n    \r\n    </div>\r\n\r\n</div>\r\n\r\n<button mat-raised-button color=\"primary\"\r\n    [disabled]=\"selectedItemIndex < 0\"\r\n    (click)=\"closeDialog(selectedItemIndex)\"\r\n    *ngIf=\"data.texts.length > 3\">\r\n\r\n    {{data.texts[3]}}\r\n    \r\n</button>", styles: [":host{min-height:300px}h3{margin-top:0;margin-bottom:10px}p{margin-top:0;margin-bottom:5px}.searchItemInputContainer{width:100%;margin-top:0;margin-bottom:0}.listItemsContainer{overflow-y:auto;border:1px solid rgba(0,0,0,.2);border-radius:4px;margin-bottom:5px}.listItemContainer p{line-height:36px;width:calc(100% - 12px);margin:0 0 0 6px}button{float:right}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1.MatDialogRef }, { type: BrowserService }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * A dialog component with a single input element and an accept button, to be used with dialog service
 * It lets us easily ask the user for any arbitrary text we may need.
 *
 * 1st text is the dialog title
 * 2nd text is the dialog subtitle (leave it empty to hide the subtitle)
 * 3rd text is the input prompt caption
 * 4rd text is the default value of the input contents
 *
 * 1st option will be the text on the unique save button that exists on the dialog
 */
class DialogSingleInputComponent extends DialogBaseComponent {
    static { this.DIALOG_CLASS_NAME = 'DialogSingleInputComponent'; }
    constructor(elementRef, dialogRef, data) {
        super(elementRef, dialogRef);
        this.elementRef = elementRef;
        this.dialogRef = dialogRef;
        this.data = data;
        /**
         * Contains the text that the user types on the dialog input
         */
        this.inputText = '';
        /**
        * Contains the default text that's been specified for the input
        */
        this.defaultTextValue = '';
        if (data.texts.length < 1) {
            throw new Error('DialogSingleInputComponent expects 1 text: The dialog title');
        }
        if (data.options.length !== 1) {
            throw new Error('DialogSingleInputComponent expects only one option');
        }
        if (data.texts.length > 3) {
            this.inputText = data.texts[3];
            this.defaultTextValue = data.texts[3];
        }
    }
    isButtonDisabled() {
        if (this.defaultTextValue !== '' && this.inputText === this.defaultTextValue) {
            return true;
        }
        return StringUtils.isEmpty(this.inputText);
    }
    closeDialog() {
        super.closeDialog(0, this.inputText);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogSingleInputComponent, deps: [{ token: i0.ElementRef }, { token: i1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: DialogSingleInputComponent, isStandalone: true, selector: "tg-dialog-single-input", providers: [], usesInheritance: true, ngImport: i0, template: "<h3>\r\n    {{data.texts[0]}}\r\n</h3>\r\n\r\n<p *ngIf=\"data.texts.length > 1 && data.texts[1] !== ''\">\r\n    {{data.texts[1]}}\r\n</p>\r\n\r\n<mat-form-field>\r\n\r\n    <mat-label>{{data.texts[2]}}</mat-label>\r\n    <input matInput autoFocusOnDisplay autoSelectTextOnFocus\r\n        (keyup.enter)=\"closeDialog()\"\r\n        [(ngModel)]=\"inputText\">\r\n        \r\n</mat-form-field>\r\n\r\n<button mat-raised-button color=\"primary\"\r\n    [disabled]=\"isButtonDisabled()\"\r\n    (click)=\"closeDialog()\">\r\n    \r\n    {{data.options[0]}}\r\n    \r\n</button>", styles: [":host{min-height:300px}h3{margin-top:1vh;margin-bottom:3vh}p{margin-top:0;margin-bottom:5vh}button{min-height:5vh}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i3.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i4.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatLabel, selector: "mat-label" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i5.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "ngmodule", type: TurboGuiAngularModule }, { kind: "directive", type: AutoFocusOnDisplayDirective, selector: "[autoFocusOnDisplay]" }, { kind: "directive", type: AutoSelectTextOnFocusDirective, selector: "[autoSelectTextOnFocus]" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: DialogSingleInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tg-dialog-single-input', imports: [CommonModule, MatButtonModule, MatInputModule, FormsModule,
                        TurboGuiAngularModule], providers: [], template: "<h3>\r\n    {{data.texts[0]}}\r\n</h3>\r\n\r\n<p *ngIf=\"data.texts.length > 1 && data.texts[1] !== ''\">\r\n    {{data.texts[1]}}\r\n</p>\r\n\r\n<mat-form-field>\r\n\r\n    <mat-label>{{data.texts[2]}}</mat-label>\r\n    <input matInput autoFocusOnDisplay autoSelectTextOnFocus\r\n        (keyup.enter)=\"closeDialog()\"\r\n        [(ngModel)]=\"inputText\">\r\n        \r\n</mat-form-field>\r\n\r\n<button mat-raised-button color=\"primary\"\r\n    [disabled]=\"isButtonDisabled()\"\r\n    (click)=\"closeDialog()\">\r\n    \r\n    {{data.options[0]}}\r\n    \r\n</button>", styles: [":host{min-height:300px}h3{margin-top:1vh;margin-bottom:3vh}p{margin-top:0;margin-bottom:5vh}button{min-height:5vh}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * This is the base class for all button components
 */
class ButtonBaseComponent {
    constructor() {
        /**
         * Defines the actual opacity that is binded on the html part
         */
        this.currentOpacity = .7;
        /**
         * Defines the actual scale that is binded on the html part
         */
        this.currentScale = 'scale(1)';
        /**
         * Defines if the button can be clicked or not
         */
        this.pointerEvents = 'initial';
        /**
         * Specifies if the button animations must rollback when the user releases the mouse or pointer after pressing it
         */
        this.releaseOnMouseUp = true;
        /**
         * Specifies the amount of milliseconds that the button will vibrate when it gets clicked (only on compatible devices and browsers)
         * Set it to 0 to disable click vibration
         */
        this.vibrateOnClick = 25;
        /**
         * Defines the button opacity when it is not clicked
         */
        this.defaultOpacity = .7;
        /**
         * Defines the image scale when it is not clicked
         */
        this.defaultScale = 1;
        /**
         * Defines the button opacity when it is hovered
         */
        this.hoverOpacity = .8;
        /**
         * Defines the image scale when it is hovered
         */
        this.hoverScale = 1;
        /**
         * Defines the button opacity when it is clicked
         */
        this.clickOpacity = 1;
        /**
         * Defines the image scale when it is clicked
         */
        this.clickScale = 1;
        /**
         * Defines the button opacity when it is disabled
         */
        this.disabledOpacity = .2;
        /**
         * Stores the value that tells if the button is enabled or disabled
         */
        this._enabled = true;
    }
    /**
     * Specifies if the button is enabled or disabled
     */
    set enabled(v) {
        this._enabled = v;
        this.currentOpacity = v ? this.defaultOpacity : this.disabledOpacity;
        this.pointerEvents = v ? 'initial' : 'none';
    }
    ;
    /**
     * Set button default values
     */
    ngOnInit() {
        this.currentOpacity = this._enabled ? this.defaultOpacity : this.disabledOpacity;
        this.currentScale = 'scale(1)';
    }
    /**
     * Listens for the mouse over the button component
     */
    onMouseOver() {
        if (this._enabled) {
            this.currentOpacity = this.hoverOpacity;
            this.currentScale = 'scale(' + this.hoverScale + ')';
        }
    }
    /**
     * Listens for the mouse out of the button component
     */
    onMouseOut() {
        if (this._enabled) {
            this.currentOpacity = this.defaultOpacity;
            this.currentScale = 'scale(' + this.defaultScale + ')';
        }
    }
    /**
     * Listens for the mouse down on the button component
     */
    onMouseDown() {
        if (this._enabled) {
            this.currentOpacity = this.clickOpacity;
            this.currentScale = 'scale(' + this.clickScale + ')';
        }
    }
    /**
     * Listens for the mouse up of the button component
     */
    onMouseUp() {
        if (this._enabled) {
            if (this.vibrateOnClick > 0 && window.navigator && window.navigator.vibrate) {
                window.navigator.vibrate(this.vibrateOnClick);
            }
            if (this.releaseOnMouseUp) {
                this.currentOpacity = this.defaultOpacity;
                this.currentScale = 'scale(' + this.defaultScale + ')';
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ButtonBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.2.5", type: ButtonBaseComponent, isStandalone: true, inputs: { releaseOnMouseUp: "releaseOnMouseUp", vibrateOnClick: "vibrateOnClick", defaultOpacity: "defaultOpacity", defaultScale: "defaultScale", hoverOpacity: "hoverOpacity", hoverScale: "hoverScale", clickOpacity: "clickOpacity", clickScale: "clickScale", disabledOpacity: "disabledOpacity", enabled: "enabled" }, host: { listeners: { "mouseover": "onMouseOver()", "mouseout": "onMouseOut()", "pointerout": "onMouseOut()", "pointerleave": "onMouseOut()", "pointerdown": "onMouseDown()", "pointerup": "onMouseUp()" }, properties: { "style.opacity": "this.currentOpacity", "style.transform": "this.currentScale", "style.pointer-events": "this.pointerEvents" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ButtonBaseComponent, decorators: [{
            type: Directive
        }], propDecorators: { currentOpacity: [{
                type: HostBinding,
                args: ['style.opacity']
            }], currentScale: [{
                type: HostBinding,
                args: ['style.transform']
            }], pointerEvents: [{
                type: HostBinding,
                args: ['style.pointer-events']
            }], releaseOnMouseUp: [{
                type: Input
            }], vibrateOnClick: [{
                type: Input
            }], defaultOpacity: [{
                type: Input
            }], defaultScale: [{
                type: Input
            }], hoverOpacity: [{
                type: Input
            }], hoverScale: [{
                type: Input
            }], clickOpacity: [{
                type: Input
            }], clickScale: [{
                type: Input
            }], disabledOpacity: [{
                type: Input
            }], enabled: [{
                type: Input
            }], onMouseOver: [{
                type: HostListener,
                args: ['mouseover']
            }], onMouseOut: [{
                type: HostListener,
                args: ['mouseout']
            }, {
                type: HostListener,
                args: ['pointerout']
            }, {
                type: HostListener,
                args: ['pointerleave']
            }], onMouseDown: [{
                type: HostListener,
                args: ['pointerdown']
            }], onMouseUp: [{
                type: HostListener,
                args: ['pointerup']
            }] } });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * This component is a basic button that uses an image as its visual appearance
 */
class ButtonImageComponent extends ButtonBaseComponent {
    constructor() {
        super(...arguments);
        /**
         * This is used to attach the fade animation directly to this component so it fades in and out when created and removed from the app
         */
        this.buttonFade = true;
        /**
         * Defines the path to the image that is shown by this button
         */
        this.src = '';
        /**
         * Defines the percentual size of the image based on the button size. 100 means the image will fill the whole button,
         * 50 only half, etc..
         */
        this.percentSize = 100;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ButtonImageComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: ButtonImageComponent, isStandalone: true, selector: "tg-button-image", inputs: { src: "src", percentSize: "percentSize" }, host: { properties: { "@buttonFade": "this.buttonFade" } }, providers: [], usesInheritance: true, ngImport: i0, template: "<img src=\"{{src}}\"\r\n    [style.width]=\"percentSize + '%'\"\r\n    [style.height]=\"percentSize + '%'\" />", styles: [":host{-webkit-user-select:none;user-select:none;overflow:hidden;cursor:pointer;-webkit-tap-highlight-color:transparent;transition:opacity .3s ease,transform .2s cubic-bezier(.04,.62,.58,1);display:flex;justify-content:center;align-items:center}img{pointer-events:none;-webkit-user-select:none;user-select:none;-webkit-tap-highlight-color:transparent}\n"], animations: [FadeAnimationClass.getTrigger('buttonFade', '300ms ease', '300ms ease')] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ButtonImageComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tg-button-image', imports: [], providers: [], animations: [FadeAnimationClass.getTrigger('buttonFade', '300ms ease', '300ms ease')], template: "<img src=\"{{src}}\"\r\n    [style.width]=\"percentSize + '%'\"\r\n    [style.height]=\"percentSize + '%'\" />", styles: [":host{-webkit-user-select:none;user-select:none;overflow:hidden;cursor:pointer;-webkit-tap-highlight-color:transparent;transition:opacity .3s ease,transform .2s cubic-bezier(.04,.62,.58,1);display:flex;justify-content:center;align-items:center}img{pointer-events:none;-webkit-user-select:none;user-select:none;-webkit-tap-highlight-color:transparent}\n"] }]
        }], propDecorators: { buttonFade: [{
                type: HostBinding,
                args: ['@buttonFade']
            }], src: [{
                type: Input
            }], percentSize: [{
                type: Input
            }] } });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * This component is a basic button without visual appearance, that is used as a container to load any content.
 */
class ButtonContainerComponent extends ButtonBaseComponent {
    constructor() {
        super(...arguments);
        /**
         * This is used to attach the fade animation directly to this component so it fades in and out when created and removed from the app
         */
        this.buttonFade = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ButtonContainerComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.5", type: ButtonContainerComponent, isStandalone: true, selector: "tg-button-container", host: { properties: { "@buttonFade": "this.buttonFade" } }, providers: [], usesInheritance: true, ngImport: i0, template: "<ng-content></ng-content>", styles: [":host{-webkit-user-select:none;user-select:none;overflow:hidden;cursor:pointer;-webkit-tap-highlight-color:transparent;transition:opacity .3s ease,transform .2s cubic-bezier(.04,.62,.58,1);display:flex;justify-content:center;align-items:center}\n"], animations: [FadeAnimationClass.getTrigger('buttonFade', '300ms ease', '300ms ease')] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.5", ngImport: i0, type: ButtonContainerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tg-button-container', imports: [], providers: [], animations: [FadeAnimationClass.getTrigger('buttonFade', '300ms ease', '300ms ease')], template: "<ng-content></ng-content>", styles: [":host{-webkit-user-select:none;user-select:none;overflow:hidden;cursor:pointer;-webkit-tap-highlight-color:transparent;transition:opacity .3s ease,transform .2s cubic-bezier(.04,.62,.58,1);display:flex;justify-content:center;align-items:center}\n"] }]
        }], propDecorators: { buttonFade: [{
                type: HostBinding,
                args: ['@buttonFade']
            }] } });

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Defines the data that is contained inside a GUI notification
 */
class GUINotification {
    constructor(name, type = '', data = null) {
        /**
         * The name for this notification
         */
        this.name = '';
        /**
         * An optional type to categorize this notification in case the name is not enough
         * to uniquely identify it
         */
        this.type = '';
        /**
         * Additional data to send with the notification
         */
        this.data = null;
        this.name = name;
        this.type = type;
        this.data = data;
    }
}

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * This is a base class that helps managing our application pages.
 * We should extend this class to create our application pages, as it forces us to set the viewContainerRef and the viewService,
 * which are both used when working with pages.
 *
 * IMPORTANT!!! View services are created and destroyed when the page is created and destroyed. It is vital to specify the view service
 * as a provider for the page to ensure that it will be created and destroyed when the view is created and destroyed.
 *
 * Example:
 *
 * @Component({
 *   ...
 *   selector: 'app-my-view-page',
 *   providers: [MyViewService]
 *   ...
 *})
 */
class View {
    /**
     * This constructor is specifically designed to force the following:
     *
     * - Set the viewContainerRef which will be automatically assigned to the respective view service.
     *
     * - If the view has no service, we can set it to null, but it is recommended to always use a service with a view, to store the view state and global methods
     */
    constructor(viewContainerRef, viewService) {
        this.viewContainerRef = viewContainerRef;
        this.viewService = viewService;
        if (viewService !== null) {
            viewService.viewContainerRef = viewContainerRef;
        }
    }
}

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Defines a service that is attached to an application view.
 * All our service components that are linked to a view must extend this class so they can be correctly initialized at the view constructor.
 */
class ViewService {
}

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Sometimes it is necessary to apply some kind of buffer to the user input for certain operations that may be executed
 * several times but we need to capture only the latest of them into a certain period of time. This class does exactly this:
 * we can queue as many times as we want a specific method call and only the last one will be executed under a defined window of time.
 * So for example if a user types keys on an input, we can buffer it for x seconds and perform a request only with the last of its changes.
 * Lots of other UI interaction usages may be interesting with this class.
 */
class DelayedMethodCallManager {
    /**
     * Sometimes it is necessary to apply some kind of buffer to the user input for certain operations that may be executed
     * several times but we need to capture only the latest of them into a certain period of time. This class does exactly this:
     * we can queue as many times as we want a specific method call and only the last one will be executed under a defined window of time.
     * So for example if a user types keys on an input, we can buffer it for x seconds and perform a request only with the last of its changes.
     * Lots of other UI interaction usages may be interesting with this class.
     *
     * @param delay Amount of time to wait before executing the operations . Defaults to 1000 miliseconds.
     */
    constructor(delay = 1000) {
        this.delay = delay;
        this._functionsToExecute = [];
        this._timerIsRunning = false;
        this._setTimeoutHandler = null;
    }
    /**
     * Add a method to be called once the delay time is finished.
     * Every time a new call to queue is performed, the delay timer is restarted. When the delay time finishes, only the
     * last of the methods that have been pushed by call() will be executed.
     *
     * Use it to queue several user input operations that should be called only once in a period of time, while waiting
     * for the user to finish his input.
     *
     * @param method The function that will be queued for execution after the delay time has passed
     */
    queue(method) {
        this._functionsToExecute.push(method);
        if (this._timerIsRunning) {
            clearTimeout(this._setTimeoutHandler);
        }
        this._timerIsRunning = true;
        this._setTimeoutHandler = setTimeout(() => { this.run(); }, this.delay);
    }
    /**
     * Abort all methods that may have been pushed to this class and are waiting to be executed, so none of them
     * is executed when the delay time finishes. Basically everything is cleared and stoped when this method is called.
     */
    cancel() {
        if (this._setTimeoutHandler !== null) {
            clearTimeout(this._setTimeoutHandler);
        }
        this._functionsToExecute = [];
        this._timerIsRunning = false;
    }
    /**
     * Auxiliary function that performs the call to the latest queued method
     */
    run() {
        this._functionsToExecute.pop()();
        this._functionsToExecute = [];
        this._timerIsRunning = false;
    }
}

/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
/**
 * Validation class that extends the base angular Form Validators class and adds extra useful validators
 */
class ValidatorsPlus extends Validators {
    /**
     * Verify that the data of a form value is required and also Not semantically empty, just like the
     * TurboCommons StringUtils.isEmpty method does
     */
    static nonEmpty(control) {
        // Apply first the required validation
        let validateRequired = Validators.required(control);
        if (validateRequired !== null) {
            return validateRequired;
        }
        // first check if the control has a value
        if (control.value && control.value.length > 0) {
            if (!StringUtils.isEmpty(control.value)) {
                return null;
            }
            else {
                return { isEmpty: true };
            }
        }
        else {
            return null;
        }
    }
}

/*
 * Public API Surface of turbogui-angular
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AutoFocusOnDisplayDirective, AutoSelectTextOnFocusDirective, BrowserService, BusyStateBaseComponent, ButtonContainerComponent, ButtonImageComponent, DelayedMethodCallManager, DialogBaseComponent, DialogDateSelectionComponent, DialogErrorComponent, DialogIFrameComponent, DialogMultipleOptionComponent, DialogService, DialogSingleInputComponent, DialogSingleOptionComponent, DialogSingleSelectionListComponent, DialogTwoOptionComponent, ElementClickOutsideDirective, ElementCreatedDirective, ElementDestroyedDirective, FadeAnimationClass, GUINotification, GlobalErrorService, HTTPService, HTTPServiceGetRequest, HTTPServicePostRequest, LocalesBaseService, NotificationService, RouterBaseService, SingletoneStrictClass, TurboApiService, TurboGuiAngularModule, ValidatorsPlus, View, ViewService };
//# sourceMappingURL=turbogui-angular.mjs.map
