import { BrowserManager } from 'turbocommons-ts';
import { Location, PopStateEvent } from '@angular/common';
import * as i0 from "@angular/core";
/**
 * An abstraction of the browser entity an all its related operations and properties
 */
export declare class BrowserService extends BrowserManager {
    private readonly location;
    constructor(location: Location);
    /**
     * Modify the current browser URI without reloading the current page document
     *
     * @param path The uri value we want to set
     * @param query The query url parameters part we want to specify if any
     *
     * @returns void
     */
    setCurrentUrlURI(path: string, query?: string | undefined): void;
    /**
     * Obtain a subscription to get notified on any changes at the browser url
     *
     * @param onNext A method to be executed every time the url changes on the browser. The url will be available inside the value parameter
     *
     * @returns Subscribed events. Make sure to unsubscribe when not needed
     */
    subscribeToUrlChange(onNext: (value: PopStateEvent) => void): import("rxjs").SubscriptionLike;
    static ɵfac: i0.ɵɵFactoryDeclaration<BrowserService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<BrowserService>;
}
//# sourceMappingURL=browser.service.d.ts.map