import { HTTPManager, HTTPManagerBaseRequest } from 'turbocommons-ts';
import { DialogService } from './dialog.service';
import * as i0 from "@angular/core";
/**
 * Manages application http communications
 */
export declare class HTTPService extends HTTPManager {
    dialogService: DialogService;
    constructor(dialogService: DialogService);
    /**
     * The same method as HTTPManager.execute but with the ability to enable several options which are specific to this service:
     *
     * - options:
     *     busyState: Set it to false to prevent the default behaviour of locking the UI while the request is running
     *     handleErrors: Set it to false to prevent the default behaviour of showing a detailed error dialog when a request fails
     *
     * @see HTTPManager.execute()
     */
    execute(requests: string | string[] | HTTPManagerBaseRequest | HTTPManagerBaseRequest[], finishedCallback?: ((results: {
        url: string;
        response: any;
        isError: boolean;
        errorMsg: string;
        code: number;
    }[], anyError: boolean) => void) | null, progressCallback?: null | ((completedUrl: string, totalRequests: number) => void), options?: {
        busyState?: boolean;
        handleErrors?: boolean;
    }): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<HTTPService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<HTTPService>;
}
//# sourceMappingURL=http.service.d.ts.map