/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
import { OnInit } from '@angular/core';
import { ButtonBaseComponent } from '../../../view/components/button-base/button-base.component';
import * as i0 from "@angular/core";
export declare class ButtonImageComponent extends ButtonBaseComponent implements OnInit {
    /**
     * This is used to attach the fade animation directly to this component so it fades in and out when created and removed from the app
     */
    buttonFade: boolean;
    /**
     * Defines the path to the image that is shown by this button
     */
    src: string;
    /**
     * Defines the percentual size of the image based on the button size. 100 means the image will fill the whole button,
     * 50 only half, etc..
     */
    percentSize: number;
    static ɵfac: i0.ɵɵFactoryDeclaration<ButtonImageComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ButtonImageComponent, "tg-button-image", never, { "src": { "alias": "src"; "required": false; }; "percentSize": { "alias": "percentSize"; "required": false; }; }, {}, never, never, true, never>;
}
//# sourceMappingURL=button-image.component.d.ts.map