/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
import { AfterViewInit, ElementRef } from '@angular/core';
import { MatDialogRef } from '@angular/material/dialog';
import * as i0 from "@angular/core";
/**
 * This is the base class for all the dialog components that can be loaded by the dialog service class
 */
export declare abstract class DialogBaseComponent implements AfterViewInit {
    elementRef: ElementRef;
    dialogRef: MatDialogRef<DialogBaseComponent>;
    static readonly DIALOG_CLASS_NAME: string;
    constructor(elementRef: ElementRef, dialogRef: MatDialogRef<DialogBaseComponent>);
    ngAfterViewInit(): void;
    /**
     * Method to be called by the dialogs that extend this base component when they want to close themselves.
     * It will perform the close of that dialog and also send an object to the addDialog() callback with the index and value
     * that the user may have selected.
     *
     * @param index The numeric index of the user option selection. It will be specific for each dialog and it's different available options
     * @param value Any value that may be provided to the callback regarding the user selected option.
     *
     * @return void
     */
    closeDialog(index: number, value?: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DialogBaseComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DialogBaseComponent, "ng-component", never, {}, {}, never, never, false, never>;
}
//# sourceMappingURL=dialog-base.component.d.ts.map