/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
import { ElementRef } from '@angular/core';
import { MatDialogRef } from '@angular/material/dialog';
import { DialogBaseComponent } from '../dialog-base/dialog-base.component';
import * as i0 from "@angular/core";
export declare class DialogSingleInputComponent extends DialogBaseComponent {
    elementRef: ElementRef;
    dialogRef: MatDialogRef<DialogBaseComponent>;
    data: any;
    static readonly DIALOG_CLASS_NAME = "DialogSingleInputComponent";
    /**
     * Contains the text that the user types on the dialog input
     */
    inputText: string;
    /**
    * Contains the default text that's been specified for the input
    */
    defaultTextValue: string;
    constructor(elementRef: ElementRef, dialogRef: MatDialogRef<DialogBaseComponent>, data: any);
    isButtonDisabled(): boolean;
    closeDialog(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DialogSingleInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DialogSingleInputComponent, "tg-dialog-single-input", never, {}, {}, never, never, true, never>;
}
//# sourceMappingURL=dialog-single-input.component.d.ts.map