/**
 * TurboGUI is A library that helps with the most common and generic UI elements and functionalities
 *
 * Website : -> http://www.turbogui.org
 * License : -> Licensed under the Apache License, Version 2.0. You may not use this file except in compliance with the License.
 * License Url : -> http://www.apache.org/licenses/LICENSE-2.0
 * CopyRight : -> Copyright 2018 Edertone Advanded Solutions. https://www.edertone.com
 */
import { FormControl, Validators } from '@angular/forms';
/**
 * Validation class that extends the base angular Form Validators class and adds extra useful validators
 */
export declare class ValidatorsPlus extends Validators {
    /**
     * Verify that the data of a form value is required and also Not semantically empty, just like the
     * TurboCommons StringUtils.isEmpty method does
     */
    static nonEmpty(control: FormControl): import("@angular/forms").ValidationErrors | null;
}
//# sourceMappingURL=ValidatorsPlus.d.ts.map